"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SMS = void 0;
const RawNonQuery_1 = require("../lib/model/RawNonQuery");
const RawQuery_1 = require("../lib/model/RawQuery");
const RawView_1 = require("../lib/view/RawView");
const Str = require('@supercharge/strings');
class SMS {
    _key;
    _secret;
    _priority;
    _account;
    req;
    res;
    constructor() {
        this._key = "";
        this._secret = "";
        this._priority = "";
        this._account = "";
    }
    get key() {
        return this._key;
    }
    set key(val) {
        this._key = val;
    }
    get secret() {
        return this._secret;
    }
    set secret(val) {
        this._secret = val;
    }
    get priority() {
        return this._priority;
    }
    set priority(val) {
        this._priority = val;
    }
    get account() {
        return this._account;
    }
    set account(val) {
        this._account = val;
    }
    getType(did) {
        let rate_type;
        did = "" + did + "";
        let len = did.length - 10;
        let number = did.slice(len, did.length);
        let digit = number.slice(0, 3);
        if ((digit == 800 || digit == 822 || digit == 833 || digit == 844 || digit == 855 || digit == 866 || digit == 877 || digit == 888) && number.length == 10) {
            rate_type = "toll_free";
        }
        else if (number.length == 10) {
            rate_type = "10_dlc";
        }
        else {
            rate_type = "short_code";
        }
        return rate_type;
    }
    getRate(req, res, tariff, type, subcategory, callback) {
        let obj1 = new RawQuery_1.ModelRawQuery(req, res);
        obj1.qrysql = "SELECT `MT_rates` FROM `sms_rate` WHERE `id_tariff`='" + tariff + "'  AND `subcategory`='" + subcategory + "' LIMIT 1";
        obj1.prepare();
        obj1.execute((err, sms_rate) => {
            console.log(err, sms_rate);
            if (sms_rate.length > 0) {
                callback('', sms_rate);
            }
            else {
                callback(err, '');
            }
        });
    }
    getLrnDetails(req, res, did, callback) {
        console.log("Did", did);
        did = "" + did + "";
        let len = did.length - 10;
        let number = did.slice(len, did.length);
        let npa = number.slice(0, 3);
        let nxx = number.slice(3, 6);
        let obj1 = new RawQuery_1.ModelRawQuery(req, res);
        obj1.qrysql = "SELECT npa,block, lata, ocn, lata, state, co_name_spec_c, li.category, IFNULL(o.id,0) idoperator, IFNULL(sr.rates,0) rates,IFNULL(o.name,'') `name` FROM (SELECT * FROM `lerg_info` WHERE npa='" + npa + "' AND nxx='" + nxx + "') li LEFT JOIN `lerg_operator` lo  ON lo.operator=li.co_name_spec_c AND lo.category=li.category LEFT JOIN `operator_mapping` om ON om.idlerg_operator=lo.idlerg_operator LEFT JOIN `operator` o ON om.idoperator=o.id LEFT JOIN (SELECT * FROM `surcharge_rates` WHERE direction='outbound' AND subtype='SMS' AND category='none' AND TYPE='10DLC') sr ON sr.idoperator=o.id";
        obj1.prepare();
        obj1.execute((err, lrn_details) => {
            console.log("====", err, lrn_details);
            if (err == 1) {
                callback('', { message: "LRN Found Successfully", status: 200, data: lrn_details });
            }
            else {
                callback({ message: "Query Error", status: 502 }, '');
            }
        });
    }
    saveSMS(req, res, next, sessdata, lerg_data, sms_provider, callback) {
        const uuid = Str.random(30);
        let sdata = req.body;
        let TO = "" + sdata.TO.trim() + "";
        let len = TO.length - 10;
        let FROM = "+1" + sdata.FROM.trim();
        let To = "+1" + sdata.TO.trim();
        let number_type = this.getType(sdata.TO);
        let msg_data = sdata.BODY.replace(/"/g, '\\"').replace(/'/g, "\\'");
        this.getRate(req, res, sessdata.idtariff, number_type, "SMS", (error, sms_rate) => {
            if (sms_rate || sessdata.isMobileVerify == "false" && sessdata.isEmailVerify == "true") {
                console.log("sms_rate", sms_rate);
                let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                obj.nonqrysql = "INSERT INTO `mdr` (`batch_id`, `to_number`, `MT_rates`,`from_number`, `messsage_body`,`status`,`npa`,`state`,`idaccount`,`iduser`,`number_type`,`connection_key`,`sms_outbound_key`,`ocn`,`lata`,`category`,`mobility`,`idapi`,`MT_surcharge`,`idoperator`,`operator`) VALUES('" + uuid + "','" + sdata.TO + "','" + sms_rate[0].MT_rates + "','" + sdata.FROM + "','" + msg_data + "','dispatched','" + lerg_data[0].npa + "','" + lerg_data[0].state + "','" + sessdata.idaccount + "','" + sessdata.iduser + "','" + number_type + "','" + sdata.Connection + "','" + sdata.OutboundSMS + "','" + lerg_data[0].ocn + "','" + lerg_data[0].lata + "','" + lerg_data[0].category + "','" + lerg_data[0].co_name_spec_c + "','" + sessdata.idapi + "','" + lerg_data[0].rates + "','" + lerg_data[0].idoperator + "','" + lerg_data[0].name + "')";
                obj.prepare();
                obj.execute((error, responce) => {
                    let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                    obj.nonqrysql = "INSERT INTO `send_sms` (`sender`, `receiver`,`msgdata`,`time`,`smsc_id`,`dlr_mask`, `service`,`coding`) VALUES('" + FROM + "','" + To + "','" + msg_data + "',UNIX_TIMESTAMP(),'" + sms_provider + "','11','" + responce.insertId + "','0')";
                    obj.prepare();
                    obj.execute((msg_err, msg_resp) => {
                        if (msg_err == 1 && msg_resp.insertId) {
                            let objv = new RawQuery_1.ModelRawQuery(req, res);
                            objv.qrysql = "SELECT `batch_id` FROM `mdr` WHERE `idmdr`='" + responce.insertId + "'";
                            objv.prepare();
                            objv.execute((mdr_err, mdr_resp) => {
                                if (mdr_err == 1 && mdr_resp.length > 0) {
                                    let obj = new RawView_1.RawView(res);
                                    obj.prepare({ status: 201, message: "SMS Submit Successfully", batch_id: mdr_resp[0].batch_id });
                                    obj.execute();
                                }
                                else {
                                    let obj = new RawView_1.RawView(res);
                                    obj.prepare({ status: 502, message: "Something went wrong!" });
                                    obj.execute();
                                }
                            });
                        }
                        else {
                            callback({ status: 502, message: "Something went wrong!" }, '');
                        }
                    });
                });
            }
            else {
                callback(error, '');
            }
        });
    }
    saveMMS(req, res, next, sessdata, lerg_data, sms_provider, callback) {
        const uuid = Str.random(30);
        let sdata = req.body;
        let TO = "" + sdata.TO + "";
        let len = TO.length - 10;
        let number_type = this.getType(sdata.TO);
        this.getRate(req, res, sessdata.idtariff, number_type, "SMS", (error, sms_rate) => {
            if (sms_rate) {
                console.log("sms_rate", sms_rate);
                var npa = TO.slice(len, len + 3);
                let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                obj.nonqrysql = "INSERT INTO `mdr` (`batch_id`, `to_number`, `MT_rates`,`from_number`, `messsage_body`,`status`,`npa`,`state`,`idaccount`,`iduser`,`number_type`,`connection_key`,`sms_outbound_key`,`ocn`,`lata`,`category`,`mobility`,`idapi`) VALUES('" + uuid + "','" + sdata.TO + "','" + sms_rate[0].MT_rates + "','" + sdata.FROM + "','" + sdata.BODY + "','dispatched','" + lerg_data[0].npa + "','" + lerg_data[0].state + "','" + sessdata.idaccount + "','" + sessdata.iduser + "','" + number_type + "','" + sdata.Connection + "','" + sdata.OutboundSMS + "','" + lerg_data[0].ocn + "','" + lerg_data[0].lata + "','" + lerg_data[0].category + "','" + lerg_data[0].co_name_spec_c + "','" + sessdata.idapi + "')";
                obj.prepare();
                obj.execute((error, responce) => {
                    let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                    obj.nonqrysql = "INSERT INTO `send_sms` (`sender`, `receiver`,`msgdata`,`time`,`smsc_id`,`dlr_mask`, `service`) VALUES('" + sdata.FROM + "','" + sdata.TO + "','" + sdata.BODY + "',UNIX_TIMESTAMP(),'" + sms_provider + "','11','" + responce.insertId + "')";
                    obj.prepare();
                    obj.execute((msg_err, msg_resp) => {
                        if (msg_resp.insertId) {
                            callback('', { message: "Sms submit successfully" });
                        }
                        else {
                            callback({ message: 'Something went wrong' }, '');
                        }
                    });
                });
            }
            else {
                callback(error, '');
            }
        });
    }
}
exports.SMS = SMS;
