"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OsrApi = void 0;
const RawNonQuery_1 = require("../lib/model/RawNonQuery");
const RawQuery_1 = require("../lib/model/RawQuery");
const numberRegistry_1 = require("../include/numberRegistry");
const RawView_1 = require("../lib/view/RawView");
const cron = require('node-cron');
let request = require('request');
const produrl = 'http://65.214.42.91:84/osr/v2/entries/';
const devurl = 'http://osrdev-e1.netnumber.net:84/osr/v2/entries/';
const myip = "iplink";
const nnid = "104141";
class OsrApi extends numberRegistry_1.NumberRegistry {
    constructor(proirity, sessdata) {
        super(proirity, sessdata);
    }
    /* <===  Osr Update Or Add Osr Entry Type1 ==> */
    addNumber(req, res, callback) {
        let sdata = req.body;
        let did = sdata.DID;
        let len = did.length - 10;
        let number = did.slice(len, did.length);
        let number1 = "+1" + number;
        let options = {
            'method': 'PUT',
            'url': produrl + "" + `${number1}`,
            'headers': {
                'Content-Type': 'application/json'
            },
            body: '{id:"' + myip + '", nnid: "' + nnid + '"}'
        };
        console.log("options", options);
        request(options, (error, response) => {
            if (!error) {
                let data = JSON.parse(response.body);
                if (data.message == "Success") {
                    let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                    obj.nonqrysql = "UPDATE `did_buy` SET `osr_status` = 'register' where `iduser` = '" + this.sessdata.iduser + "' AND `did`='" + number + "'";
                    obj.prepare();
                    obj.execute((err, resp) => {
                        if (resp) {
                            if (sdata.CampaignId !== undefined) {
                            }
                            else {
                                let obj = new RawView_1.RawView(res);
                                obj.prepare({ status: 201, message: "DID buy and osr Submit Successfully" });
                                obj.execute();
                            }
                        }
                        return callback(err, '');
                    });
                }
            }
            else {
                callback(error, "");
            }
        });
    }
    /* <===  Osr Update Entry Type2 ==> */
    updateNumber(req, res, did_id, callback) {
        let sdata = req.body;
        let did = sdata.DID.trim();
        let len = did.length - 10;
        let number = did.slice(len, did.length);
        let number1 = "+1" + number;
        if (sdata.CampaignId != null && sdata.CampaignId != '') {
            let objc = new RawQuery_1.ModelRawQuery(req, res);
            objc.qrysql = "SELECT `myip`, `nnid`, `sms_provider` FROM `osr_nnid` WHERE `sms_provider`=(SELECT upstreamCnpId FROM `campaign` WHERE `campaign_key`='" + sdata.CampaignId + "' AND `deleted`=0 LIMIT 1)";
            objc.prepare();
            objc.execute((camp_err, camp_result) => {
                if (camp_err == 1 && camp_result.length > 0) {
                    let options = {
                        'method': 'PUT',
                        'url': produrl + "" + `${number1}`,
                        'headers': {
                            'Content-Type': 'application/json'
                        },
                        body: '{ id: "' + camp_result[0].myip + '", nnid:"' + camp_result[0].nnid + '" , "context": "A2P", "campaign_id": "' + sdata.CampaignId + '" }'
                    };
                    request(options, (error, response) => {
                        if (!error) {
                            let data = JSON.parse(response.body);
                            if (data.message == "Success") {
                                let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                obj.nonqrysql = "UPDATE `did_buy` SET `osr_status` = 'register', `sms_provider`='" + camp_result[0].sms_provider + "' WHERE `iduser` = '" + this.sessdata.iduser + "' AND `did`='" + number + "'";
                                obj.prepare();
                                obj.execute((err, resp) => {
                                    if (err == 1) {
                                        let obj2 = new RawQuery_1.ModelRawQuery(req, res);
                                        obj2.qrysql = "SELECT `did` FROM `did_buy` WHERE `iddid`='" + did_id + "' ";
                                        obj2.prepare();
                                        obj2.execute((did_err, did_result) => {
                                            if (did_err == 1) {
                                                let obj = new RawView_1.RawView(res);
                                                obj.prepare({ status: 201, message: "DID Buy and osr Submit Successfully", result: did_result });
                                                obj.execute();
                                            }
                                        });
                                    }
                                    else {
                                        let obj = new RawView_1.RawView(res);
                                        obj.prepare({ status: 502, message: "Something went wrong with connection!" });
                                        obj.execute();
                                    }
                                });
                            }
                            else {
                                let obj2 = new RawQuery_1.ModelRawQuery(req, res);
                                obj2.qrysql = "SELECT `did` FROM `did_buy` WHERE `iddid`='" + did_id + "' ";
                                obj2.prepare();
                                obj2.execute((did_err, did_result) => {
                                    if (did_err == 1) {
                                        let obj = new RawView_1.RawView(res);
                                        obj.prepare({ status: 400, message: "DID Buy Successfully but OSR Submission Failed", DID: did_result, error: data });
                                        obj.execute();
                                    }
                                });
                            }
                        }
                        else {
                            let obj2 = new RawQuery_1.ModelRawQuery(req, res);
                            obj2.qrysql = "SELECT `did` FROM `did_buy` WHERE `iddid`='" + did_id + "' ";
                            obj2.prepare();
                            obj2.execute((did_err, did_result) => {
                                if (did_err == 1) {
                                    let obj = new RawView_1.RawView(res);
                                    obj.prepare({ status: 400, message: "DID Buy Successfully but OSR Submission Failed", DID: did_result, error: error });
                                    obj.execute();
                                }
                            });
                        }
                    });
                }
                else {
                    let obj = new RawView_1.RawView(res);
                    obj.prepare({ status: 400, message: "DID Buy Successfully but OSR Submission Failed", DID: sdata, error: "Campaign Not found" });
                    obj.execute();
                }
            });
        }
        else {
            let obj = new RawView_1.RawView(res);
            obj.prepare({ status: 400, message: "DID Buy Successfully but OSR Submission Failed", DID: sdata, error: "Campaign Not found" });
            obj.execute();
        }
    }
    /* <=== toll-free provisioning Osr Update Entry Type3 ==> */
    updateNumberWithTollfree(req, res, callback) {
        let sdata = req.body;
        let options = {
            'method': 'PUT',
            'url': 'https://208.254.45.98/osr/v2/entries/1800551212',
            'headers': {
                'Content-Type': 'application/json'
            },
            body: JSON.stringify({ "id": "mypid", "nnid": "123456", "context": "A2P", "ownertspid": "3434" })
        };
        request(options, (error, response) => {
            if (!error) {
                let ddata = JSON.parse(response.body);
                if (ddata.rows.length > 0) {
                }
                else {
                    let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                    obj.prepare();
                    obj.execute((err, data) => {
                        callback(err, data);
                    });
                }
            }
            else {
                let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                obj.prepare();
                obj.execute((err, data) => {
                    callback(err, data);
                });
            }
        });
    }
    /* <=== Delete OSR Entry ===> */
    deleteNumber(req, res, callback) {
        let sdata = req.query;
        let did = sdata.DID;
        let len = did.length - 10;
        let number = did.slice(len, did.length);
        let number1 = "1" + number;
        let options = {
            'method': 'DELETE',
            'url': produrl + "" + `${number1}`,
            'headers': {
                'Content-Type': 'application/json'
            },
            body: '{id:"' + myip + '", nnid: "' + nnid + '"}'
        };
        request(options, (error, response) => {
            if (!error) {
                let data = JSON.parse(response.body);
                if (data.message == "Success") {
                    let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                    obj.nonqrysql = "UPDATE `did_buy` SET `osr_status` = 'unregister', where `iduser` = '" + this.sessdata.iduser
                        + "' AND `did`='" + number + "'";
                    obj.prepare();
                    obj.execute((err, resp) => {
                        if (err == 1) {
                            let obj = new RawView_1.RawView(res);
                            obj.prepare({ status: 202, message: "Disable Offnetsms successfully" });
                            obj.execute();
                        }
                        else {
                            let obj = new RawView_1.RawView(res);
                            obj.prepare({ status: 502, message: "Something Went Wrong" });
                            obj.execute();
                        }
                    });
                }
                else {
                    let obj = new RawView_1.RawView(res);
                    obj.prepare({ status: data.response_code, message: data.message, result: data });
                    obj.execute();
                }
            }
            else {
                let obj = new RawView_1.RawView(res);
                obj.prepare({ status: 400, error: error });
                obj.execute();
            }
        });
    }
    retrieveOsrEntry(req, res, callback) {
        let sdata = req.query;
        let did = sdata.DID.trim();
        let len = did.length - 10;
        let number = did.slice(len, did.length);
        let number1 = "1" + number;
        let options = {
            'method': 'GET',
            'url': produrl + "" + number1 + "?id=" + myip,
            'headers': {
                'Content-Type': 'application/json'
            }
        };
        console.log("options", options);
        request(options, (error, response) => {
            if (!error) {
                let data = JSON.parse(response.body);
                console.log("Data", data);
                if (data.message == "Success") {
                    let obj = new RawView_1.RawView(res);
                    obj.prepare({ status: 200, message: "OSR Details Find Successfully", result: data });
                    obj.execute();
                }
                else {
                    let obj = new RawView_1.RawView(res);
                    obj.prepare({ status: data.response_code, message: data.message, result: data });
                    obj.execute();
                }
            }
            else {
                let obj = new RawView_1.RawView(res);
                obj.prepare({ status: 400, result: error });
                obj.execute();
            }
        });
    }
    retrieveOsrNotifications(req, res, callback) {
        let sdata = req.query;
        let options = {
            'method': 'GET',
            'url': "http://65.214.42.91:84/osr/v2/notifications?id=" + myip + "&tid=" + sdata.TID,
            'headers': {
                'Content-Type': 'application/json'
            }
        };
        console.log("options", options);
        request(options, (error, response) => {
            if (!error) {
                let data = JSON.parse(response.body);
                console.log("Data", data);
                let obj = new RawView_1.RawView(res);
                obj.prepare({ status: 200, message: "OSR Details Find Successfully", result: data });
                obj.execute();
            }
            else {
                let obj = new RawView_1.RawView(res);
                obj.prepare({ status: 400, result: error });
                obj.execute();
            }
        });
    }
    /**
     * For bulk DID purchase callback method
     */
    updateNumber_CB(req, res, did_id, callback) {
        let sdata = req.body;
        let did = sdata.DID.trim();
        let len = did.length - 10;
        let number = did.slice(len, did.length);
        let number1 = "+1" + number;
        if (sdata.CampaignId != null && sdata.CampaignId != '') {
            let objc = new RawQuery_1.ModelRawQuery(req, res);
            objc.qrysql = "SELECT `myip`, `nnid`, `sms_provider` FROM `osr_nnid` WHERE `sms_provider`=(SELECT upstreamCnpId FROM `campaign` WHERE `campaign_key`='" + sdata.CampaignId + "' AND `deleted`=0 LIMIT 1)";
            objc.prepare();
            objc.execute((camp_err, camp_result) => {
                if (camp_err == 1 && camp_result.length > 0) {
                    let options = {
                        'method': 'PUT',
                        'url': produrl + "" + `${number1}`,
                        'headers': {
                            'Content-Type': 'application/json'
                        },
                        body: '{ id: "' + camp_result[0].myip + '", nnid:"' + camp_result[0].nnid + '" , "context": "A2P", "campaign_id": "' + sdata.CampaignId + '" }'
                    };
                    request(options, (error, response) => {
                        if (!error) {
                            let data = JSON.parse(response.body);
                            if (data.message == "Success") {
                                let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                obj.nonqrysql = "UPDATE `did_buy` SET `osr_status` = 'register', `sms_provider`='" + camp_result[0].sms_provider + "' WHERE `iduser` = '" + this.sessdata.iduser + "' AND `did`='" + number + "'";
                                obj.prepare();
                                obj.execute((err, resp) => {
                                    if (err == 1) {
                                        let obj2 = new RawQuery_1.ModelRawQuery(req, res);
                                        obj2.qrysql = "SELECT `did` FROM `did_buy` WHERE `iddid`='" + did_id + "' ";
                                        obj2.prepare();
                                        obj2.execute((did_err, did_result) => {
                                            callback(did_err, { error: 0, status: 200, message: "DID Buy and osr Submit Successfully", result: did_result });
                                        });
                                    }
                                    else {
                                        callback(err, { error: 1, status: 400, message: "Something went wrong with connection!" });
                                    }
                                });
                            }
                            else {
                                let obj2 = new RawQuery_1.ModelRawQuery(req, res);
                                obj2.qrysql = "SELECT `did` FROM `did_buy` WHERE `iddid`='" + did_id + "' ";
                                obj2.prepare();
                                obj2.execute((did_err, did_result) => {
                                    callback(did_err, { error: 0, status: 200, message: "DID Buy Successfully but OSR Submission Failed!", DID: did_result });
                                });
                            }
                        }
                        else {
                            let obj2 = new RawQuery_1.ModelRawQuery(req, res);
                            obj2.qrysql = "SELECT `did` FROM `did_buy` WHERE `iddid`='" + did_id + "' ";
                            obj2.prepare();
                            obj2.execute((did_err, did_result) => {
                                callback(did_err, { error: 0, status: 200, message: "DID Buy Successfully but OSR Submission Failed!", DID: did_result });
                            });
                        }
                    });
                }
                else {
                    callback(camp_err, { error: 1, status: 400, message: "DID Buy Successfully but OSR Submission Failed!" });
                }
            });
        }
        else {
            callback("", { error: 1, status: 400, message: "DID Buy Successfully but OSR Submission Failed!" });
        }
    }
}
exports.OsrApi = OsrApi;
