"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PeerlessAPI = void 0;
const APIBase_1 = require("./APIBase");
const RawNonQuery_1 = require("../lib/model/RawNonQuery");
const RawQuery_1 = require("../lib/model/RawQuery");
const RawView_1 = require("../lib/view/RawView");
const Osr_1 = require("./Osr");
const numberApi_1 = require("./numberApi");
var request = require('request');
var convert = require('xml-js');
class PeerlessAPI extends APIBase_1.APIBase {
    url;
    customer;
    passCode;
    userId;
    soapenv;
    pub;
    key;
    secret;
    priority;
    sessdata;
    timekey;
    constructor(proirity, sessdata, timekey) {
        super();
        this.customer = "TRAYTECKdba";
        this.passCode = "F6EBSVEJ";
        this.userId = "jeremy.kelley_stg@iplinktelecom.com";
        this.soapenv = "http://schemas.xmlsoap.org/soap/envelope/";
        this.pub = "http://publicapi.api.s2.peerless.com/";
        this.url = "https://aniweb02.peerlessnetwork.com:8181/public/APIService?wsdl";
        this.priority = proirity;
        this.key = "";
        this.secret = "";
        this.timekey = timekey,
            this.sessdata = sessdata;
    }
    getNpaNxx(req, res, callback) {
        if (this.priority == "100") {
            callback('', '');
        }
        else {
            this.getRate(req, res, this.sessdata.idtariff, "voice", "NN", (err, voice_rate) => {
                let condition = "";
                if (req.query.NPA && (req.query.NXX == '' || req.query.NXX == 'null')) {
                    condition = '<npas><npa>' + req.query.NPA + '</npa></npas>';
                }
                else if (req.query.NPA && req.query.NXX) {
                    condition = '<npas><npa>' + req.query.NPA + '</npa></npas><nxxs><nxx>' + req.query.NXX + '</nxx></nxxs>';
                }
                const qty = req.query.Qty;
                let data = '<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:pub="http://publicapi.api.s2.peerless.com/"><soapenv:Body><pub:searchNumbers><authentication><customer>' + this.customer + '</customer><passCode>' + this.passCode + '</passCode><userId>' + this.userId + '</userId></authentication><filters>' + condition + '<quantity>' + qty + '</quantity><consecutive>1</consecutive><vanityDigits>?</vanityDigits><categories><category>1</category><category>2</category></categories><selectedTN><tn>?</tn></selectedTN></filters></pub:searchNumbers></soapenv:Body></soapenv:Envelope>';
                let options = {
                    'method': 'POST',
                    'url': this.url,
                    'body': data,
                    'headers': {
                        'Content-Type': 'text/xml',
                        'SOAPAction': 'searchNumbers'
                    },
                };
                request(options, (error, response, body) => {
                    if (body) {
                        let tmp = body;
                        var result1 = convert.xml2json(tmp, { compact: true, spaces: 4 });
                        var res1 = JSON.parse(result1);
                        let check = res1["S:Envelope"]["S:Body"]["ns2:searchNumbersResponse"]["return"]["tnCount"];
                        if (check._text > '0') {
                            let ddata = res1["S:Envelope"]["S:Body"]["ns2:searchNumbersResponse"]["return"]["result"]["tn"];
                            if (!ddata.length) {
                                ddata = [ddata];
                            }
                            if (ddata !== undefined && ddata.length > 0) {
                                let str = ddata;
                                let obj1 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                let qrystr = "INSERT INTO `did_search` (`friendly_name`, `phone_number`, `lata`, `locality`, `rate_center`, `state`, `postal_code`, `capabilities` ,`city`, `provider`,`iduser`,`idaccount`, `priorty`,`key`,`type`,`rates`) VALUE ";
                                str.forEach((ele) => {
                                    qrystr += "('','" + ele.number._text + "','', '', '', '', '', '', '' ,'" + "Peerless" + "','" + this.sessdata.iduser + "', '" + this.sessdata.idaccount + "', '" + this.priority + "','" + this.timekey + "','NN','" + voice_rate[0].rate + "'),";
                                });
                                obj1.nonqrysql = qrystr.slice(0, -1);
                                obj1.prepare();
                                obj1.execute((err, data) => {
                                    callback(err, data);
                                });
                            }
                            else {
                                callback('', ddata);
                            }
                        }
                        else {
                            let obj = new RawView_1.RawView(res);
                            obj.prepare({ status: 502, message: "No DID Found!" });
                            obj.execute();
                        }
                    }
                    else {
                        callback('', error);
                    }
                });
            });
        }
    }
    getByRate(req, res, callback) {
        if (this.priority == "100") {
            callback('', '');
        }
        else {
            this.getRate(req, res, this.sessdata.idtariff, "voice", "NN", (err, voice_rate) => {
                if (err == 1 && voice_rate.length > 0) {
                    const state = req.query.State;
                    const rate_center = req.query.RateCenter;
                    const qty = req.query.Qty;
                    let data = '<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:pub="http://publicapi.api.s2.peerless.com/"><soapenv:Body><pub:searchNumbers><authentication><customer>' + this.customer + '</customer><passCode>' + this.passCode + '</passCode><userId>' + this.userId + '</userId></authentication><filters><states><state>' + state + '</state></states><rateCenters><rateCenter>' + rate_center + '</rateCenter></rateCenters><quantity>' + qty + '</quantity><consecutive>1</consecutive><vanityDigits>?</vanityDigits><categories><category>1</category><category>2</category></categories><selectedTN><tn>?</tn></selectedTN></filters></pub:searchNumbers></soapenv:Body></soapenv:Envelope>';
                    let options = {
                        'method': 'POST',
                        'url': this.url,
                        'body': data,
                        'headers': {
                            'Content-Type': 'text/xml',
                            'SOAPAction': 'searchNumbers'
                        },
                    };
                    request(options, (error, response, body) => {
                        if (!error) {
                            let tmp = body;
                            var result1 = convert.xml2json(tmp, { compact: true, spaces: 4 });
                            var res1 = JSON.parse(result1);
                            var check = res1["S:Envelope"]["S:Body"]["ns2:searchNumbersResponse"]["return"]["tnCount"];
                            if (check._text > '0') {
                                var ddata = res1["S:Envelope"]["S:Body"]["ns2:searchNumbersResponse"]["return"]["result"]["tn"];
                                if (!ddata.length) {
                                    ddata = [ddata];
                                }
                                let rateCenter = res1["S:Envelope"]["S:Body"]["ns2:searchNumbersResponse"]["return"]["rateCenters"]["rateCenter"]["_text"];
                                let state = res1["S:Envelope"]["S:Body"]["ns2:searchNumbersResponse"]["return"]["states"]["state"]["_text"];
                                if (ddata !== undefined && ddata.length > 0) {
                                    let str = ddata;
                                    let obj1 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                    let qrystr = "INSERT INTO `did_search` (`iduser`,`friendly_name`, `phone_number`, `lata`, `locality`, `rate_center`, `state`, `postal_code`, `capabilities` ,`city`, `provider`, `idaccount`, `priorty`,`key`,`type`,`rates`) VALUE ";
                                    str.forEach((ele) => {
                                        qrystr += "('" + this.sessdata.iduser + "', '','" + ele.number._text + "', '', '', '" + rateCenter + "','" + state + "', '', '', '','" + "Peerless" + "', '" + this.sessdata.idaccount + "', '" + this.priority + "','" + this.timekey + "','NN','" + voice_rate[0].rate + "'),";
                                    });
                                    obj1.nonqrysql = qrystr.slice(0, -1);
                                    obj1.prepare();
                                    obj1.execute((err, data) => {
                                        callback(err, data);
                                    });
                                }
                                else {
                                    callback('', ddata);
                                }
                            }
                            else {
                                let obj = new RawView_1.RawView(res);
                                obj.prepare({ status: 502, message: "No DID Found!" });
                                obj.execute();
                            }
                        }
                        else {
                            callback('', error);
                        }
                    });
                }
                else {
                    callback(err, voice_rate);
                }
            });
        }
    }
    getTollFree(req, res, callback) {
        if (this.priority == "100") {
            return;
        }
        else {
            const tollfree = req.query.TF_PREFIX;
            const qty = req.query.Qty;
            let options = {
                'method': 'POST',
                'url': 'https://devapi.coretel.net/cgi-bin/xmlnumberdb.pl',
                'body': "<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"no\"?><RequestType>VanitySearch</RequestType><Purpose>SIP</Purpose><Quantity>" + qty + "</Quantity><Tollfree>" + tollfree + "</Tollfree><BillingAccount>" + this.key + "</BillingAccount><Password>" + this.secret + "</Password></xml>",
                rejectUnauthorized: false,
                requestCert: true,
                agent: false
            };
            request(options, (error, response, body) => {
                if (!error) {
                    let tmp = body;
                    let valid_xml = tmp.slice(0, -6);
                    console.log(valid_xml);
                    var result1 = convert.xml2json(valid_xml, { compact: true, spaces: 4 });
                    var res1 = JSON.parse(result1);
                    let ddata = res1.xml.SearchResult;
                    console.log("Data==>", ddata);
                    if (ddata !== undefined && ddata.length > 0) {
                        let str = ddata;
                        let obj1 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                        let qrystr = "INSERT INTO `did_search` (`friendly_name`, `phone_number`, `lata`, `locality`, `rate_center`, `state`, `postal_code`, `capabilities` ,`city`, `provider`, `idaccount`, `priorty`) VALUE ";
                        str.forEach((ele) => {
                            console.log(ele.Number._text);
                            qrystr += "('','" + ele.Number._text + "', '', '', '" + ele.RateCenter._text + "', '', '', '', '' ,'" + "coreTel" + "', '" + this.sessdata.idaccount + "', '" + this.priority + "'),";
                        });
                        obj1.nonqrysql = qrystr.slice(0, -1);
                        obj1.prepare();
                        obj1.execute((err, data) => {
                            callback(err, data);
                        });
                    }
                    else {
                        callback('', ddata);
                    }
                }
                else {
                    callback('', error);
                }
            });
        }
    }
    buyDID(req, res, callback) {
        const sdata = req.body;
        let did = sdata.DID.trim();
        let len = did.length - 10;
        let npa = did.slice(len, len + 3);
        let nxx = did.slice(len + 3, len + 6);
        let id_grouporder = sdata.id_grouporder;
        this.getRateCenter(req, res, npa, nxx, (err, ratecenter_state) => {
            let ratecenter = ratecenter_state[0] !== undefined ? ratecenter_state[0].rc_abbre : '';
            let state = ratecenter_state[0] !== undefined ? ratecenter_state[0].loc_state : '';
            let obj1 = new RawQuery_1.ModelRawQuery(req, res);
            obj1.qrysql = "SELECT `type`,`rates` from `did_search` WHERE `iduser`='" + this.sessdata.iduser + "' AND `phone_number`='" + sdata.DID.trim() + "'";
            obj1.prepare();
            obj1.execute((err, did_details) => {
                if (did_details.length > 0) {
                    let objv0 = new RawQuery_1.ModelRawQuery(req, res);
                    objv0.qrysql = "SELECT t.proration FROM `user`u JOIN `tariff`t ON u.idtariff=t.idtariff WHERE iduser= '" + this.sessdata.iduser + "'";
                    objv0.prepare();
                    objv0.execute((proration_error, proration_success) => {
                        if (proration_error == 1) {
                            let proration_status = proration_success[0].proration;
                            if (did_details[0].type != "TF") {
                                let data = '<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:pub="http://publicapi.api.s2.peerless.com/"><soapenv:Body><pub:placeOrder><authentication><customer>' + this.customer + '</customer><passCode>' + this.passCode + '</passCode><userId>' + this.userId + '</userId></authentication><order><orderType>NN</orderType><orderNumbers><number><tn>' + sdata.DID.trim() + '</tn><mou>1000</mou><routeLabel>PROV_TEST</routeLabel><peerlessMsgProvisioning>?</peerlessMsgProvisioning></number></orderNumbers></order></pub:placeOrder></soapenv:Body></soapenv:Envelope>';
                                let options = {
                                    'method': 'POST',
                                    'url': this.url,
                                    'headers': {
                                        'Content-Type': 'text/xml',
                                        'SOAPAction': 'placeOrder'
                                    },
                                    body: data,
                                };
                                request(options, (error, response, body) => {
                                    let tmp = body;
                                    var result1 = convert.xml2json(tmp, { compact: true, spaces: 4 });
                                    let res1 = JSON.parse(result1);
                                    let order = res1["S:Envelope"]["S:Body"]["ns2:placeOrderResponse"]["return"]["_text"];
                                    if (!error) {
                                        if (order) {
                                            let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                            obj.nonqrysql = "INSERT INTO `did_buy` (`account_id`, `user_id`, `status`, `did`,`provider`,`order_id`,`type`,`iduser`,`disconnect_did_status`,`npa`,`nxx`,`state`,`ratecenter`,`inbound_key`,`outbound_key`,`connection_key`,`sms_inbound_key`,`sms_outbound_key`,`rates`,`camp_registry`,`idapi`) VALUE('','','completed','" + sdata.DID.trim() + "','Peerless','" + order + "','NN','" + this.sessdata.iduser + "','1','" + npa + "','" + nxx + "','" + state + "','" + ratecenter + "','" + sdata.InboundVoice + "','" + sdata.OutboundVoice + "','" + sdata.Connection + "','" + sdata.InboundSMS + "','" + sdata.OutboundSMS + "','" + did_details[0].rates + "','" + sdata.CampaignId + "','" + this.sessdata.idapi + "')";
                                            obj.prepare();
                                            obj.execute((err, data) => {
                                                if (err == 1) {
                                                    let dateObj = new Date();
                                                    let day = dateObj.getUTCDate();
                                                    let totalDays = 30 - day + 1;
                                                    let prorate;
                                                    if (proration_status == "true") {
                                                        prorate = (totalDays * did_details[0].rates) / 30;
                                                    }
                                                    else {
                                                        prorate = did_details[0].rates;
                                                    }
                                                    prorate = typeof prorate != 'undefined' && prorate > 0 ? prorate : 0;
                                                    let objv = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                    objv.nonqrysql = "UPDATE `wallet` SET `balance`=`balance`-" + prorate + " WHERE `idaccount`='" + this.sessdata.idaccount + "'";
                                                    objv.prepare();
                                                    objv.execute((wallet_error, wallet_success) => {
                                                        let iQry = "INSERT INTO `wallet_recharge_log` SET ";
                                                        iQry += "`idaccount`=" + this.sessdata.idaccount + ", ";
                                                        iQry += "`amount`='-" + prorate + "', ";
                                                        iQry += "`purpose`='Wallet amount successfully updated for buy a new DID', ";
                                                        iQry += "`status`=1;";
                                                        let objWL = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                        objWL.nonqrysql = iQry;
                                                        objWL.prepare();
                                                        objWL.execute((error, result) => {
                                                        });
                                                        let objv1 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                        objv1.nonqrysql = "INSERT INTO `did_log` (`account_id`, `user_id`, `status`, `did`,`provider`,`order_id`,`type`,`iduser`,`disconnect_did_status`,`npa`,`nxx`,`state`,`ratecenter`,`rates`,`idapi`,`pro_rates`) VALUE('','','completed','" + sdata.DID.trim() + "','Peerless','" + order + "','NN','" + this.sessdata.iduser + "','1','" + npa + "','" + nxx + "','" + state + "','" + ratecenter + "','" + did_details[0].rates + "','" + this.sessdata.idapi + "','" + prorate + "')";
                                                        objv1.prepare();
                                                        objv1.execute((log_error, did_log) => {
                                                            let obj5 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                            obj5.nonqrysql = "DELETE FROM `did_cart` WHERE did='" + sdata.DID + "'";
                                                            obj5.prepare();
                                                            obj5.execute((walletError, wallet) => {
                                                                let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                                obj.nonqrysql = "INSERT INTO `did_order` (`iduser`, `idaccount`, `status`, `did`,`error_code`,`order_no`, `type`, `cost`, `description`, `id_grouporder`) VALUE('" + this.sessdata.iduser + "','" + this.sessdata.idaccount + "','','" + sdata.DID + "', '2', '" + order + "', 'NN', '" + did_details[0].rates + "', '', " + id_grouporder + ")";
                                                                obj.prepare();
                                                                obj.execute((did_err, did_data) => {
                                                                    if (sdata.CampaignId) {
                                                                        let osr = new Osr_1.OsrApi(this.priority, this.sessdata);
                                                                        osr.updateNumber(req, res, data.insertId, (error, responce) => {
                                                                            if (responce) {
                                                                                return callback('', responce);
                                                                            }
                                                                            else {
                                                                                callback(error, '');
                                                                            }
                                                                        });
                                                                    }
                                                                    else {
                                                                        let obj2 = new RawQuery_1.ModelRawQuery(req, res);
                                                                        obj2.qrysql = "SELECT `did` FROM `did_buy` WHERE `iddid`='" + data.insertId + "' ";
                                                                        obj2.prepare();
                                                                        obj2.execute((did_err, did_result) => {
                                                                            if (did_err == 1) {
                                                                                let obj = new RawView_1.RawView(res);
                                                                                obj.prepare({ status: 201, message: "DID buy successfully", result: did_result });
                                                                                obj.execute();
                                                                            }
                                                                        });
                                                                    }
                                                                });
                                                            });
                                                        });
                                                    });
                                                }
                                                else {
                                                    let obj = new RawView_1.RawView(res);
                                                    obj.prepare({ status: 502, message: "Something went wrong with connection!" });
                                                    obj.execute();
                                                }
                                            });
                                        }
                                        else {
                                            let obj = new RawView_1.RawView(res);
                                            obj.prepare({ status: 502, message: "Something Went Wrong" });
                                            obj.execute();
                                        }
                                    }
                                    else {
                                        let obj = new RawView_1.RawView(res);
                                        obj.prepare({ status: 404, message: "DID not Available!" });
                                        obj.execute();
                                    }
                                });
                            }
                            else {
                                let obj = new RawView_1.RawView(res);
                                obj.prepare({ status: 502, message: "TF DID not available on this Provider!" });
                                obj.execute();
                            }
                        }
                        else {
                            let obj = new RawView_1.RawView(res);
                            obj.prepare({ status: 502, message: "Something went wrong with get proration!" });
                            obj.execute();
                        }
                    });
                }
                else {
                    let objv = new RawView_1.RawView(res);
                    objv.prepare({ status: 404, message: "Did Not Available" });
                    objv.execute();
                }
            });
        });
    }
    disconnectDID(req, res, callback) {
        const sdata = req.body;
        let obj1 = new RawQuery_1.ModelRawQuery(req, res);
        obj1.qrysql = "SELECT `day_num` from `tariff` WHERE `idtariff`='" + this.sessdata.idtariff + "'";
        obj1.prepare();
        obj1.execute((errday, resday) => {
            if (errday == 1 && resday.length > 0) {
                let number = new numberApi_1.Number();
                number.countDays(req, res, sdata.DID.trim(), (err, countdays) => {
                    if (countdays) {
                        if (countdays > resday[0].day_num) {
                            let obj2 = new RawQuery_1.ModelRawQuery(req, res);
                            obj2.qrysql = "SELECT `type` from `did_buy` WHERE `iduser`='" + this.sessdata.iduser + "' AND `did`='" + sdata.DID.trim() + "'";
                            obj2.prepare();
                            obj2.execute((err, resu) => {
                                if (resu.length > 0) {
                                    let data = '<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:pub="http://publicapi.api.s2.peerless.com/"><soapenv:Body><pub:disconnectOrder><authentication><customer>' + this.customer + '</customer><passCode>' + this.passCode + '</passCode><userId>' + this.userId + '</userId></authentication><disconnectOrderRequest><pon>?</pon><tns><tn>' + sdata.DID.trim() + '</tn><discoType>1</discoType></tns></disconnectOrderRequest></pub:disconnectOrder></soapenv:Body></soapenv:Envelope>';
                                    var options = {
                                        'method': 'POST',
                                        'url': this.url,
                                        'headers': {
                                            'Content-Type': 'text/xml',
                                            'SOAPAction': 'disconnectOrder'
                                        },
                                        'body': data,
                                    };
                                    request(options, (error, response, body) => {
                                        if (!error) {
                                            let tmp = body;
                                            var result1 = convert.xml2json(tmp, { compact: true, spaces: 4 });
                                            let res1 = JSON.parse(result1);
                                            let data = res1["S:Envelope"]["S:Body"]["ns2:disconnectOrderResponse"]["return"]["_text"];
                                            if (data) {
                                                let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                obj.nonqrysql = "UPDATE `did_buy` set `disconnect_did_status`='3',`updated_at`=NOW() WHERE `did`='" + sdata.DID.trim() + "'AND `iduser`='" + this.sessdata.iduser + "'";
                                                obj.prepare();
                                                obj.execute((error, resp) => {
                                                    if (error == 1) {
                                                        let objv = new RawView_1.RawView(res);
                                                        objv.prepare({ status: 201, message: "DID Disconnected Successfully" });
                                                        objv.execute();
                                                    }
                                                    else {
                                                        let objv = new RawView_1.RawView(res);
                                                        objv.prepare({ status: 502, message: "Something Went Wrong" });
                                                        objv.execute();
                                                    }
                                                });
                                            }
                                            else {
                                                let objv = new RawView_1.RawView(res);
                                                objv.prepare({ status: data.statusCode, message: data.status });
                                                objv.execute();
                                            }
                                        }
                                        else {
                                            let objv = new RawView_1.RawView(res);
                                            objv.prepare({ status: 400, error: error });
                                            objv.execute();
                                        }
                                    });
                                }
                                else {
                                    let objv = new RawView_1.RawView(res);
                                    objv.prepare({ status: 502, message: "Something went wrong with connection!" });
                                    objv.execute();
                                }
                            });
                        }
                        else {
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({ status: 417, message: "Days are Less then " + resday[0].day_num + " So you can not disconnect Did from this Account" });
                            objv.execute();
                        }
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ status: 404, message: "Data Not Found" });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new RawView_1.RawView(res);
                objv.prepare({ status: 502, message: "Days Not Found!" });
                objv.execute();
            }
        });
    }
    /**
     * For bulk DID purchase callback method
     */
    buyDID_CB(req, res, DID, callback) {
        const sdata = req.body;
        let did = DID.trim();
        let len = did.length - 10;
        let npa = did.slice(len, len + 3);
        let nxx = did.slice(len + 3, len + 6);
        let id_grouporder = sdata.id_grouporder;
        this.getRateCenter(req, res, npa, nxx, (err, ratecenter_state) => {
            let ratecenter = ratecenter_state[0] !== undefined ? ratecenter_state[0].rc_abbre : '';
            let state = ratecenter_state[0] !== undefined ? ratecenter_state[0].loc_state : '';
            let obj1 = new RawQuery_1.ModelRawQuery(req, res);
            obj1.qrysql = "SELECT `type`,`rates` from `did_search` WHERE `iduser`='" + this.sessdata.iduser + "' AND `phone_number`='" + DID.trim() + "'";
            obj1.prepare();
            obj1.execute((err, did_details) => {
                if (did_details.length > 0) {
                    let objv0 = new RawQuery_1.ModelRawQuery(req, res);
                    objv0.qrysql = "SELECT t.proration FROM `user`u JOIN `tariff`t ON u.idtariff=t.idtariff WHERE iduser= '" + this.sessdata.iduser + "'";
                    objv0.prepare();
                    objv0.execute((proration_error, proration_success) => {
                        if (proration_error == 1) {
                            let proration_status = proration_success[0].proration;
                            if (did_details[0].type != "TF") {
                                let data = '<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:pub="http://publicapi.api.s2.peerless.com/"><soapenv:Body><pub:placeOrder><authentication><customer>' + this.customer + '</customer><passCode>' + this.passCode + '</passCode><userId>' + this.userId + '</userId></authentication><order><orderType>NN</orderType><orderNumbers><number><tn>' + DID.trim() + '</tn><mou>1000</mou><routeLabel>PROV_TEST</routeLabel><peerlessMsgProvisioning>?</peerlessMsgProvisioning></number></orderNumbers></order></pub:placeOrder></soapenv:Body></soapenv:Envelope>';
                                let options = {
                                    'method': 'POST',
                                    'url': this.url,
                                    'headers': {
                                        'Content-Type': 'text/xml',
                                        'SOAPAction': 'placeOrder'
                                    },
                                    body: data,
                                };
                                request(options, (error, response, body) => {
                                    let tmp = body;
                                    var result1 = convert.xml2json(tmp, { compact: true, spaces: 4 });
                                    let res1 = JSON.parse(result1);
                                    let order = res1["S:Envelope"]["S:Body"]["ns2:placeOrderResponse"]["return"]["_text"];
                                    if (!error) {
                                        if (order) {
                                            let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                            obj.nonqrysql = "INSERT INTO `did_buy` (`account_id`, `user_id`, `status`, `did`,`provider`,`order_id`,`type`,`iduser`,`disconnect_did_status`,`npa`,`nxx`,`state`,`ratecenter`,`inbound_key`,`outbound_key`,`connection_key`,`sms_inbound_key`,`sms_outbound_key`,`rates`,`camp_registry`,`idapi`) VALUE('','','completed','" + DID.trim() + "','Peerless','" + order + "','NN','" + this.sessdata.iduser + "','1','" + npa + "','" + nxx + "','" + state + "','" + ratecenter + "','" + sdata.InboundVoice + "','" + sdata.OutboundVoice + "','" + sdata.Connection + "','" + sdata.InboundSMS + "','" + sdata.OutboundSMS + "','" + did_details[0].rates + "','" + sdata.CampaignId + "','" + this.sessdata.idapi + "')";
                                            obj.prepare();
                                            obj.execute((err, data) => {
                                                if (err == 1) {
                                                    let dateObj = new Date();
                                                    let day = dateObj.getUTCDate();
                                                    let totalDays = 30 - day + 1;
                                                    let prorate;
                                                    if (proration_status == "true") {
                                                        prorate = (totalDays * did_details[0].rates) / 30;
                                                    }
                                                    else {
                                                        prorate = did_details[0].rates;
                                                    }
                                                    prorate = typeof prorate != 'undefined' && prorate > 0 ? prorate : 0;
                                                    let objv = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                    objv.nonqrysql = "UPDATE `wallet` SET `balance`=`balance`-" + prorate + " WHERE `idaccount`='" + this.sessdata.idaccount + "'";
                                                    objv.prepare();
                                                    objv.execute((wallet_error, wallet_success) => {
                                                        let iQry = "INSERT INTO `wallet_recharge_log` SET ";
                                                        iQry += "`idaccount`=" + this.sessdata.idaccount + ", ";
                                                        iQry += "`amount`='-" + prorate + "', ";
                                                        iQry += "`purpose`='Wallet amount successfully updated for buy a new DID', ";
                                                        iQry += "`status`=1;";
                                                        let objWL = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                        objWL.nonqrysql = iQry;
                                                        objWL.prepare();
                                                        objWL.execute((error, result) => {
                                                        });
                                                        let objv1 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                        objv1.nonqrysql = "INSERT INTO `did_log` (`account_id`, `user_id`, `status`, `did`,`provider`,`order_id`,`type`,`iduser`,`disconnect_did_status`,`npa`,`nxx`,`state`,`ratecenter`,`rates`,`idapi`,`pro_rates`) VALUE('','','completed','" + DID.trim() + "','Peerless','" + order + "','NN','" + this.sessdata.iduser + "','1','" + npa + "','" + nxx + "','" + state + "','" + ratecenter + "','" + did_details[0].rates + "','" + this.sessdata.idapi + "','" + prorate + "')";
                                                        objv1.prepare();
                                                        objv1.execute((log_error, did_log) => {
                                                            let obj5 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                            obj5.nonqrysql = "DELETE FROM `did_cart` WHERE did='" + DID + "'";
                                                            obj5.prepare();
                                                            obj5.execute((walletError, wallet) => {
                                                                let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                                obj.nonqrysql = "INSERT INTO `did_order` (`iduser`, `idaccount`, `status`, `did`,`error_code`,`order_no`, `type`, `cost`, `description`, `id_grouporder`) VALUE('" + this.sessdata.iduser + "','" + this.sessdata.idaccount + "','','" + DID + "', '2', '" + order + "', 'NN', '" + did_details[0].rates + "', '', " + id_grouporder + ")";
                                                                obj.prepare();
                                                                obj.execute((did_err, did_data) => {
                                                                    if (sdata.CampaignId) {
                                                                        let osr = new Osr_1.OsrApi(this.priority, this.sessdata);
                                                                        osr.updateNumber_CB(req, res, data.insertId, (error, responce) => {
                                                                            if (responce.error == 0) {
                                                                                callback("", { error: 0, status: responce.status, message: responce.message });
                                                                            }
                                                                            else {
                                                                                callback(error, { error: 1, status: responce.status, message: responce.message });
                                                                            }
                                                                        });
                                                                    }
                                                                    else {
                                                                        let obj2 = new RawQuery_1.ModelRawQuery(req, res);
                                                                        obj2.qrysql = "SELECT `did` FROM `did_buy` WHERE `iddid`='" + data.insertId + "' ";
                                                                        obj2.prepare();
                                                                        obj2.execute((did_err, did_result) => {
                                                                            callback(did_err, { error: 0, status: 200, message: "DID buy successfully", result: did_result });
                                                                        });
                                                                    }
                                                                });
                                                            });
                                                        });
                                                    });
                                                }
                                                else {
                                                    callback(err, { error: 1, status: 502, message: "Something went wrong with connection!" });
                                                }
                                            });
                                        }
                                        else {
                                            callback(error, { error: 1, status: 502, message: "Something Went Wrong!" });
                                        }
                                    }
                                    else {
                                        callback(error, { error: 1, status: 404, message: "Did Not Available!" });
                                    }
                                });
                            }
                            else {
                                callback(proration_error, { error: 1, status: 502, message: "TF DID not available on this Provider!" });
                            }
                        }
                        else {
                            callback(proration_error, { error: 1, status: 502, message: "Something went wrong with get proration!" });
                        }
                    });
                }
                else {
                    callback(err, { error: 1, status: 404, message: "Did Not Available!" });
                }
            });
        });
    }
}
exports.PeerlessAPI = PeerlessAPI;
