"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TZ = exports.UserManagement = void 0;
const RawView_1 = require("../lib/view/RawView");
const RawNonQuery_1 = require("../lib/model/RawNonQuery");
const Session_1 = require("../lib/model/Session");
const _406_1 = require("../lib/view/406");
const AppRoute_1 = require("../lib/AppRoute");
const ModelPdfUpload_1 = require("../lib/model/ModelPdfUpload");
const RawQuery_1 = require("../lib/model/RawQuery");
const Str = require('@supercharge/strings');
var nodemailer = require("nodemailer");
const jwt = require('jsonwebtoken');
const request = require("request");
const server_1 = require("../server");
const md5_1 = __importDefault(require("md5"));
//const secret_key = "sk_test_51HAL9TGdXmhCeqBzWbxBTiVUDlCqizGP8NWwxDC8zIRKuef4i9kerhyixCqVZPw5Ik3fmfUe7BR2Wy2cUqrOZdWx00IQ2MEmbO";
class UserManagement extends AppRoute_1.AppRoute {
    constructor() {
        super();
    }
    /**
     * To authenticate user with TimeZone
     */
    getMorphingSession(req, res, next) {
        let pData = req.query;
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((err, sessdata) => {
            if (err == 1) {
                let obj = new RawQuery_1.ModelRawQuery(req, res);
                obj.qrysql = "SELECT `iduser`, `idaccount`, `username`, `type`, `default`, `idtariff`, `authkey`, `status`, `isEmailVerify`, `isMobileVerify`, `idapi`, `isAddress`, `isPlan`, `tz_diff`, `server_time`, `client_time` FROM `session` WHERE `authkey` = '" + pData.key + "'";
                obj.prepare();
                obj.execute((error, result) => {
                    if (error == 1) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Session Data Fetch Successfully!", status: 200, data: result });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Something Went Wrong to Fetch Session", status: 502, result: result });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    getLogin(req, res, next) {
        let sdata = req.body.data;
        let pass = md5_1.default(sdata.password);
        let obj = new RawQuery_1.ModelRawQuery(req, res);
        let iQry = "SELECT us.iduser, us.idaccount, us.username, us.password, us.type, us.default, us.idtariff, us.isEmailVerify, us.isMobileVerify, us.isPlan, us.isAddress, ROUND(TIME_TO_SEC(TIMEDIFF(NOW(), UTC_TIMESTAMP)) / 60) tz_diff, TIMEDIFF(NOW(), UTC_TIMESTAMP) server_time, tz.utc client_time FROM user us\n";
        iQry += "LEFT JOIN `tbl_timezone_config` tzc ON tzc.id_user=us.iduser\n";
        iQry += "LEFT JOIN `tbl_timezones` tz ON tz.id=tzc.id_timezone\n";
        iQry += "WHERE us.`username`='" + sdata.username + "';";
        obj.qrysql = iQry;
        if (obj.prepare()) {
            obj.execute((error, result) => {
                if (result.length > 0) {
                    result[0].server_time = result[0].server_time.slice(0, -3);
                    if (result[0].server_time.indexOf("+") < 0 && result[0].server_time.indexOf("-") < 0) {
                        result[0].server_time = "+" + result[0].server_time;
                    }
                    if (pass == md5_1.default(result[0].password)) {
                        let data = result[0];
                        let session = new Session_1.SessionManagment(req, res, next);
                        session.SetSession(data, (error, sessdata) => {
                            let objv = new RawView_1.RawView(res);
                            objv.prepare(data);
                            objv.execute();
                        });
                        /**
                         * It will create default timezone of user if doesn't exist
                         */
                        // if (data.client_time == null || !data.client_time) {
                        //     let obj2 = new ModelRawNonQuery(req, res);
                        //     obj2.nonqrysql = "REPLACE INTO `tbl_timezone_config`(id_timezone, id_user) VALUES(192, " + data.iduser + ");"
                        //     obj2.prepare()
                        //     obj2.execute((error: any, result: any) => {
                        //         if (error == 1) {
                        //             /**
                        //              * Update the TimeZone in user's session data
                        //              */
                        //             obj2.nonqrysql = "SELECT a.utc client_time FROM tbl_timezones a WHERE a.id=192;"
                        //             obj2.prepare()
                        //             obj2.execute((error: any, result: any) => {
                        //                 if (error == 1 && result.length > 0) {
                        //                     data.client_time = result[0].client_time
                        //                 }
                        //                 session.SetSession(data, (error: any, sessdata: any) => {
                        //                     let objv = new RawView(res);
                        //                     objv.prepare(data);
                        //                     objv.execute();
                        //                 });
                        //             })
                        //         }
                        //         else {
                        //             session.SetSession(data, (error: any, sessdata: any) => {
                        //                 let objv = new RawView(res);
                        //                 objv.prepare(data);
                        //                 objv.execute();
                        //             });
                        //         }
                        //     })
                        // }
                        /**
                         * If user's timezone exist it will continue
                         */
                        // else {
                        //     session.SetSession(data, (error: any, sessdata: any) => {
                        //         let objv = new RawView(res);
                        //         objv.prepare(data);
                        //         objv.execute();
                        //     });
                        // }
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({
                            message: "Invalid Username/Password, Kindly check again!"
                        });
                        objv.execute();
                    }
                }
                else {
                    let objv = new RawView_1.RawView(res);
                    objv.prepare({
                        message: "Invalid Username/Password, Kindly check again!"
                    });
                    objv.execute();
                }
            });
        }
        else {
            let objv = new RawView_1.RawView(res);
            objv.prepare({
                message: "Few parameter are missing in request!"
            });
            objv.execute();
        }
    }
    /**
     * To save the system timezone into user's profile
     */
    SaveSysTZ(req, res, next) {
        let sdata = null;
        try {
            sdata = JSON.parse(req.body.data);
        }
        catch (e) {
            sdata = req.body.data;
        }
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                let objr = new RawQuery_1.ModelRawQuery(req, res);
                let objv = new RawView_1.RawView(res);
                objr.qrysql = "SELECT id FROM `tbl_timezones` WHERE utc='" + sdata.utc + "' AND tzCode='" + sdata.tzCode + "';";
                objr.prepare();
                objr.execute((error, result) => {
                    if (error == 1) {
                        let id_tz = result.length > 0 ? result[0].id : 0;
                        obj.nonqrysql = "REPLACE INTO `tbl_timezone_config`(id_timezone, id_user) VALUES(" + id_tz + ", " + sessdata.iduser + ");";
                        obj.prepare();
                        obj.execute((error, result) => {
                            if (error == 1) {
                                /**
                                 * It will update the current user's
                                 * session table + session data
                                 */
                                obj.nonqrysql = "UPDATE `session` SET `client_time`='" + sdata.utc + "' WHERE `authkey`='" + sessdata.authkey + "';";
                                obj.prepare();
                                obj.execute((error, result2) => {
                                    sessdata.client_time = sdata.utc;
                                    server_1.sessiondata.set(sessdata.authkey, sessdata);
                                });
                            }
                            else {
                                objv.prepare({
                                    error: 1,
                                    message: "Something went wrong!"
                                });
                                objv.execute();
                            }
                        });
                    }
                    else {
                        objv.prepare({
                            error: 1,
                            message: "Something went wrong!"
                        });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    signUp(req, res, next) {
        let sdata = req.body.data;
        let secret = Str.random(15);
        let validationKey = jwt.sign({
            exp: Math.floor(Date.now() / 1000) + (60 * 60),
            data: sdata.email + ":" + sdata.password
        }, secret);
        var isPlan;
        var tariff;
        if (sdata.tariff1 == -1 || sdata.tariff1 == 0) {
            isPlan = false;
            tariff = '-1';
        }
        else {
            isPlan = true;
            tariff = sdata.tariff1;
        }
        if (sdata.imgUrl) {
            sdata.imgUrl = sdata.imgUrl;
        }
        else {
            sdata.imgUrl = "https://portal.signalmash.com/assets/img/icon.png";
        }
        let obj = new RawQuery_1.ModelRawQuery(req, res);
        obj.qrysql = "SELECT up.email ,u. username FROM `user` u JOIN `user_profile` up ON up.iduser=u.iduser WHERE email = '" + sdata.email + "' OR username = '" + sdata.email + "'";
        obj.prepare();
        obj.execute((_error, getEmail) => {
            if (_error == 1) {
                if (getEmail.length > 0) {
                    let objv = new RawView_1.RawView(res);
                    objv.prepare({
                        message: "Email Or Username Already Exists!",
                        status: 404
                    });
                    objv.execute();
                }
                else {
                    let obj2 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                    obj2.nonqrysql = "CALL AddUser(-1, -1, '" + sdata.email + "','" + sdata.password + "','2','" + sdata.firstName + "','" + sdata.lastName + "','" + sdata.email + "',' ','" + sdata.imgUrl + "','1', '" + tariff + "', '" + sdata.tariff2 + "', '" + sdata.status + "', '10', '0')";
                    obj2.prepare();
                    obj2.execute((__error, __res) => {
                        let iduser = __res[0];
                        if (__error == 1) {
                            let obj3 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                            obj3.nonqrysql = "UPDATE `user` SET `validationKey`='" + validationKey + "', `secret`='" + secret + "', `isPlan`='"
                                + isPlan + "', `idtariff`='" + tariff + "'  WHERE `iduser`='" + iduser[0].userid + "'";
                            obj3.prepare();
                            obj3.execute((_err, __result) => {
                                if (_err == 1) {
                                    let objA = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                    objA.nonqrysql = "UPDATE `account` SET `san`=(100000000 + '" + iduser[0].account + "') WHERE `idaccount`='" + iduser[0].account + "'";
                                    objA.prepare();
                                    objA.execute((_errAccount, __resultAccount) => {
                                        if (_errAccount == 1) {
                                            let obj4 = new RawQuery_1.ModelRawQuery(req, res);
                                            obj4.qrysql = "SELECT * FROM `email_template` WHERE type='email_verification'";
                                            obj4.prepare();
                                            obj4.execute((emlErr, emlRes) => {
                                                if (emlErr == 1) {
                                                    if (emlRes.length > 0) {
                                                        let tmpData = emlRes[0].template;
                                                        tmpData = tmpData.replace(/{FIRST_NAME}/g, sdata.firstName);
                                                        tmpData = tmpData.replace(/{LAST_NAME}/g, sdata.lastName);
                                                        tmpData = tmpData.replace(/{VALIDATION_KEY}/g, validationKey);
                                                        var smtpTransport = nodemailer.createTransport({
                                                            service: "gmail",
                                                            host: "smtp-relay.gmail.com",
                                                            port: 587,
                                                            secure: true,
                                                            auth: {
                                                                user: "donotreply@nglcommunications.com",
                                                                pass: "yr%5V9GB"
                                                            }
                                                        });
                                                        var mailOptions = {
                                                            from: 'Signalmash <donotreply@signalmash.com>',
                                                            to: sdata.email,
                                                            usernmae: sdata.email,
                                                            email: sdata.email,
                                                            subject: `${emlRes[0].subject}`,
                                                            text: "Thank You For Registration",
                                                            html: `${tmpData}`
                                                        };
                                                        smtpTransport.sendMail(mailOptions, (_emailError, emailRes) => {
                                                            if (emailRes) {
                                                                const connection_key = Str.random(30);
                                                                const randDigit = connection_key.slice(4, 12);
                                                                var rdata = [];
                                                                let obj2 = new RawQuery_1.ModelRawQuery(req, res);
                                                                obj2.filter = null;
                                                                const val = Math.floor(1000 + Math.random() * 9000);
                                                                let username = sdata.firstName + "@" + val;
                                                                let password = randDigit;
                                                                const inbound_key = Str.random(30);
                                                                const outbound_key = Str.random(30);
                                                                const val1 = Math.floor(1000 + Math.random() * 9000);
                                                                const connName = sdata.firstName + '@' + val1;
                                                                obj2.qrysql = "CALL addconnection('" + iduser[0].account + "', '" + iduser[0].userid + "', '" + connName + "', '" + connection_key + "', '" + username + "', '" + password + "', '" + inbound_key + "', '" + outbound_key + "', 'true')";
                                                                obj2.prepare();
                                                                obj2.execute((__error, allcamp) => {
                                                                    if (__error == 1) {
                                                                        let objTime = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                                        objTime.nonqrysql = "INSERT INTO `tbl_timezone_config` SET `id_timezone`=16, id_user='" + iduser[0].userid + "'";
                                                                        objTime.prepare();
                                                                        objTime.execute((errTime, sTime) => {
                                                                            if (errTime == 1) {
                                                                                let objv = new RawView_1.RawView(res);
                                                                                objv.prepare({ result: sdata, key: validationKey, iduser: iduser[0].userid, status: 201, data: emailRes, message: "Signup Successfully!" });
                                                                                objv.execute();
                                                                            }
                                                                            else {
                                                                                let objv = new RawView_1.RawView(res);
                                                                                objv.prepare({ status: 502, message: "Registered Successfully! But Default Time Zone has error", error: _emailError });
                                                                                objv.execute();
                                                                            }
                                                                        });
                                                                    }
                                                                    else {
                                                                        let objv = new RawView_1.RawView(res);
                                                                        objv.prepare({ status: 502, message: "Registered Successfully! But Default Connection Not Created", error: _emailError });
                                                                        objv.execute();
                                                                    }
                                                                });
                                                            }
                                                            else {
                                                                let objv = new RawView_1.RawView(res);
                                                                objv.prepare({ status: 401, message: "Registered Successfully! Verification Email not Send!", error: _emailError });
                                                                objv.execute();
                                                            }
                                                        });
                                                    }
                                                    else {
                                                        let objv = new RawView_1.RawView(res);
                                                        objv.prepare({ message: "Registered Successfully! Verification Email not Send!", status: 502 });
                                                        objv.execute();
                                                    }
                                                }
                                                else {
                                                    let objv = new RawView_1.RawView(res);
                                                    objv.prepare({ message: "Registered But Error With Fetching Email Data!", status: 502 });
                                                    objv.execute();
                                                }
                                            });
                                        }
                                        else {
                                            let objv = new RawView_1.RawView(res);
                                            objv.prepare({ message: "Registered But Error With Connection!", status: 502 });
                                            objv.execute();
                                        }
                                    });
                                }
                                else {
                                    let objv = new RawView_1.RawView(res);
                                    objv.prepare({ message: "Registered But Error With Connection!", status: 502 });
                                    objv.execute();
                                }
                            });
                        }
                        else {
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({ message: "Something Went Wrong with Connection!", status: 502 });
                            objv.execute();
                        }
                    });
                    // res.status(200).json({data: result, message: "Signup Successfully!"});
                }
            }
            else {
                let objv = new RawView_1.RawView(res);
                objv.prepare({ message: "Something Went with Connection!", status: 502 });
                objv.execute();
            }
        });
    }
    AdminSave(req, res, next) {
        let sdata;
        let filePath = "https://portal.signalmash.com/assets/img/icon.png";
        try {
            sdata = JSON.parse(req.body.data);
        }
        catch (e) {
            sdata = JSON.parse(req.body.data);
        }
        ;
        if (req.file) {
            const fileName = req.file.filename;
            filePath = 'https://api.signalmash.com' + '/uploads/' + fileName;
        }
        if (sdata.profile_pic) {
            filePath = sdata.profile_pic;
        }
        let session = new Session_1.SessionManagment(req, res, next);
        let msg = "";
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                if (sdata.idaccount == -1) {
                    let obj = new RawQuery_1.ModelRawQuery(req, res);
                    obj.qrysql = "SELECT up.email ,u. username FROM `user` u JOIN `user_profile` up ON up.iduser=u.iduser WHERE username = '" + sdata.user_name + "' OR email = '" + sdata.email + "'";
                    obj.prepare();
                    obj.execute((_error, getUser) => {
                        if (_error == 1) {
                            if (getUser.length > 0) {
                                let objv = new RawView_1.RawView(res);
                                objv.prepare({
                                    message: "Username or Email Already Exists!",
                                    status: 404
                                });
                                objv.execute();
                            }
                            else {
                                let obj1 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                obj1.nonqrysql = "CALL AddUser(-1, -1, '" + sdata.user_name + "','" + sdata.password + "','" + sdata.type + "','" + sdata.first_name + "','" + sdata.last_name + "','" + sdata.email + "','" + sdata.contact_number + "','" + filePath + "','1', '" + sdata.tariff1 + "', '" + sdata.tariff2 + "', '" + sdata.status + "', '" + sdata.service + "', '" + sdata.credit_limit + "')";
                                if (sdata.type == 2) {
                                    msg = "Customer Added Successfully";
                                }
                                if (sdata.type == 3) {
                                    msg = "Supplier Added Successfully";
                                }
                                obj1.prepare();
                                obj1.execute((__error, result) => {
                                    if (__error == 1) {
                                        let newRes = result[0];
                                        const connection_key = Str.random(30);
                                        const randDigit = connection_key.slice(4, 12);
                                        var rdata = [];
                                        let obj2 = new RawQuery_1.ModelRawQuery(req, res);
                                        obj2.filter = null;
                                        const val = Math.floor(1000 + Math.random() * 9000);
                                        let username = sdata.first_name + "@" + val;
                                        let password = randDigit;
                                        const inbound_key = Str.random(30);
                                        const outbound_key = Str.random(30);
                                        const val1 = Math.floor(1000 + Math.random() * 9000);
                                        const connName = sdata.first_name + '@' + val1;
                                        obj2.qrysql = "CALL addconnection('" + newRes[0].account + "', '" + newRes[0].userid + "', '" + connName + "', '" + connection_key + "', '" + username + "', '" + password + "', '" + inbound_key + "', '" + outbound_key + "', 'true')";
                                        obj2.prepare();
                                        obj2.execute((__error, allcamp) => {
                                            if (__error == 1) {
                                                let obj3 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                obj3.nonqrysql = "UPDATE `account` SET `san`=(100000000 + '" + newRes[0].account + "') WHERE `idaccount`='" + newRes[0].account + "'";
                                                obj3.prepare();
                                                obj3.execute((_uperr, __result) => {
                                                    if (_uperr == 1) {
                                                        let objTime = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                        objTime.nonqrysql = "INSERT INTO `tbl_timezone_config` SET `id_timezone`=16, id_user='" + newRes[0].userid + "'";
                                                        objTime.prepare();
                                                        objTime.execute((errTime, sTime) => {
                                                            if (errTime == 1) {
                                                                let objv = new RawView_1.RawView(res);
                                                                objv.prepare({ data: result[0], message: "Customer Added Successfully!", status: 201 });
                                                                objv.execute();
                                                            }
                                                            else {
                                                                let objv = new RawView_1.RawView(res);
                                                                objv.prepare({ status: 502, message: "Customer Added Successfully! But Default Time Zone has error", error: allcamp });
                                                                objv.execute();
                                                            }
                                                        });
                                                    }
                                                    else {
                                                        let objv = new RawView_1.RawView(res);
                                                        objv.prepare({ data: result[0], message: "Customer Added But Error With Set Time!", status: 502 });
                                                        objv.execute();
                                                    }
                                                });
                                            }
                                            else {
                                                let objv = new RawView_1.RawView(res);
                                                objv.prepare({ data: result[0], message: "Something Went Wrong With Connection!", status: 502 });
                                                objv.execute();
                                            }
                                        });
                                    }
                                    else {
                                        let objv = new RawView_1.RawView(res);
                                        objv.prepare({ data: result[0], message: "Something Went Wrong With Connection!", status: 502 });
                                        objv.execute();
                                    }
                                });
                            }
                        }
                        else {
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({ message: "Something Went Wrong With Connection!", status: 502 });
                            objv.execute();
                        }
                    });
                    // });
                }
                else {
                    let obj1 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                    obj1.nonqrysql = "CALL AddUser('" + sdata.idaccount + "', -1, '" + sdata.user_name + "','" + sdata.password + "','" + sdata.type + "','" + sdata.first_name + "','" + sdata.last_name + "','" + sdata.email + "','" + sdata.contact_number + "','" + filePath + "','0', '" + sdata.tariff1 + "','" + sdata.tariff2 + "', '" + sdata.status + "', '" + sdata.service + "', '" + sdata.credit_limit + "')";
                    if (sdata.type == 2) {
                        msg = "Customer Updated Successfully";
                    }
                    if (sdata.type == 3) {
                        msg = "Supplier Updated Successfully";
                    }
                    obj1.prepare();
                    obj1.execute((_error, result) => {
                        if (_error == 1) {
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({ data: result, message: "Customer Updated Successfully!", status: 201 });
                            objv.execute();
                        }
                        else {
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({ message: "Something Went Wrong With Connection!", status: 502 });
                            objv.execute();
                        }
                    });
                }
                //     }
                // });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    SaveUser(req, res, next) {
        let sdata;
        let filePath = "https://portal.signalmash.com/assets/img/icon.png";
        try {
            sdata = JSON.parse(req.body.data);
        }
        catch (e) {
            sdata = req.body.data;
        }
        if (req.file) {
            const fileName = req.file.filename;
            // var filePath = req.protocol + '://' + req.get("host") + "/uploads/" + fileName;
            filePath = 'https://api.signalmash.com' + '/uploads/' + fileName;
        }
        if (sdata.profile_pic != null || sdata.profile_pic != undefined) {
            filePath = sdata.profile_pic;
        }
        let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
        let session = new Session_1.SessionManagment(req, res, next);
        let message = "";
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                if (sdata.iduser == -1) {
                    let obj1 = new RawQuery_1.ModelRawQuery(req, res);
                    obj1.qrysql = "SELECT up.email ,u. username FROM `user` u JOIN `user_profile` up ON up.iduser=u.iduser WHERE username = '" + sdata.user_name + "' OR email = '" + sdata.email + "'";
                    obj1.prepare();
                    obj1.execute((_error, result) => {
                        if (_error == 1) {
                            if (result.length > 0) {
                                let objv = new RawView_1.RawView(res);
                                objv.prepare({
                                    message: "Username or Email Already Exists!",
                                    status: 404
                                });
                                objv.execute();
                            }
                            else {
                                obj.nonqrysql = "CALL AddUser('" + sessdata.idaccount + "', -1, '" + sdata.user_name + "','" + sdata.password + "','" + sdata.type + "','" + sdata.first_name + "','" + sdata.last_name + "','" + sdata.email + "','" + sdata.contact_number + "','" + filePath + "','0', '" + sdata.tariff1 + "', '" + sdata.tariff2 + "', '" + sdata.status + "', '" + sdata.service + "', '" + sdata.credit_limit + "')";
                                if (sdata.type == 2) {
                                    message = "Customer Added Successfully";
                                }
                                if (sdata.type == 3) {
                                    message = "Supplier Added Successfully";
                                }
                                obj.prepare();
                                obj.execute((__error, result) => {
                                    if (__error == 1) {
                                        let newRes = result[0];
                                        let obj3 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                        obj3.nonqrysql = "UPDATE `account` SET `san`=(100000000 + '" + newRes[0].account + "') WHERE `idaccount`='" + newRes[0].account + "'";
                                        obj3.prepare();
                                        obj3.execute((_uperr, __result) => {
                                            if (_uperr == 1) {
                                                let objTime = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                objTime.nonqrysql = "INSERT INTO `tbl_timezone_config` SET `id_timezone`=16, id_user='" + newRes[0].userid + "'";
                                                objTime.prepare();
                                                objTime.execute((errTime, sTime) => {
                                                    if (errTime == 1) {
                                                        let objv = new RawView_1.RawView(res);
                                                        objv.prepare({ data: result[0], message: "Customer Added Successfully!", status: 201 });
                                                        objv.execute();
                                                    }
                                                    else {
                                                        let objv = new RawView_1.RawView(res);
                                                        objv.prepare({ status: 502, message: "Registered Successfully! But Default Time Zone has error", error: result });
                                                        objv.execute();
                                                    }
                                                });
                                            }
                                            else {
                                                let objv = new RawView_1.RawView(res);
                                                objv.prepare({ data: result[0], message: "Customer Added But Error With Set Time!", status: 502 });
                                                objv.execute();
                                            }
                                        });
                                        // let objv = new RawView(res);
                                        // objv.prepare({ data: result[0], message: "Profile Updated Successfully!", status: 201 });
                                        // objv.execute();
                                    }
                                    else {
                                        let objv = new RawView_1.RawView(res);
                                        objv.prepare({ data: result[0], message: "Something Went Wrong With Connection!", status: 502 });
                                        objv.execute();
                                    }
                                });
                            }
                        }
                        else {
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({ data: result[0], message: "Something Went Wrong With Connection!", status: 502 });
                            objv.execute();
                        }
                    });
                }
                else {
                    obj.nonqrysql = "CALL AddUser('" + sdata.idaccount + "', " + sdata.iduser + ", '" + sdata.user_name + "','" + sdata.password + "','" + sdata.type + "','" + sdata.first_name + "','" + sdata.last_name + "','" + sdata.email + "','" + sdata.contact_number + "','" + filePath + "','0', '" + sdata.tariff1 + "','" + sdata.tariff2 + "', '" + sdata.status + "', '" + sdata.service + "', '" + sdata.credit_limit + "')";
                    if (sdata.type == 2) {
                        message = "Customer Updated Successfully";
                    }
                    if (sdata.type == 3) {
                        message = "Supplier Updated Successfully";
                    }
                    obj.prepare();
                    obj.execute((_error, result) => {
                        if (_error == 1) {
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({ data: result[0], message: "Profile Updated Successfully!", status: 201 });
                            objv.execute();
                        }
                        else {
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({ data: result, message: "Something Went Wrong With Connection!", status: 502 });
                            objv.execute();
                        }
                    });
                }
                // }
                // });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    UserList(req, res, next) {
        let sdata = req.query;
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            let msg = "";
            if (error == 1) {
                let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                if (sdata.type == "main") {
                    obj.nonqrysql = "CALL ListUser(" + sessdata.idaccount + ", " + sessdata.iduser + ", -1)";
                }
                // profile = details of account
                else if (sdata.type == "profile") {
                    obj.nonqrysql = "CALL ListUser(" + sessdata.idaccount + ", " + sessdata.iduser + ", 1)";
                }
                // detail = profile of user
                else if (sdata.type == "detail") {
                    obj.nonqrysql = "CALL ListUser(" + sessdata.idaccount + ", " + sessdata.iduser + ", 2)";
                }
                else if (sdata.type == "edit") {
                    obj.nonqrysql = "CALL ListUser(" + sdata.idaccount + ", " + sdata.iduser + ", 3)";
                }
                obj.prepare();
                obj.execute((_error, result) => {
                    if (_error == 1) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ data: result, message: "Profile Fetched Successfully!", status: 200 });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Something Went Wrong With Connection!", status: 502, error: result });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    ListUsers(req, res, next) {
        let sdata = req.query;
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            let msg = "";
            if (error == 1) {
                let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                if (sdata.type == "profile") {
                    obj.nonqrysql = "CALL ListUser(" + sdata.idaccount + ", " + sdata.iduser + ", 1)";
                }
                obj.prepare();
                obj.execute((_error, result) => {
                    if (_error == 1) {
                        if (result.length > 0) {
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({ data: result, message: "Profile Fetched Successfully!", status: 200 });
                            objv.execute();
                        }
                        else {
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({ message: "Something Went Wrong With Connection!", status: 502 });
                            objv.execute();
                        }
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Something Went Wrong With Connection!", status: 502 });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    singleUser(req, res, next) {
        let sdata = req.query;
        let iduser = req.query.type;
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            let msg = "";
            if (error == 1) {
                let obj1 = new RawQuery_1.ModelRawQuery(req, res);
                obj1.qrysql = "SELECT * FROM `user` WHERE `iduser`='" + iduser + "'";
                obj1.prepare();
                obj1.execute((_error1, result1) => {
                    if (_error1 == 1) {
                        let obj = new RawQuery_1.ModelRawQuery(req, res);
                        obj.qrysql = "SELECT b.idaccount,b.address1, b.address2,b.city,b.state,b.postal_code,b.country, w.balance,w.credit_limit FROM `billing_address` b JOIN `wallet` w ON w.idaccount = b.idaccount WHERE `b`.idaccount='" + result1[0].idaccount + "'";
                        obj.prepare();
                        obj.execute((_error, result) => {
                            if (_error == 1) {
                                let objv = new RawView_1.RawView(res);
                                objv.prepare({ data: result, data1: result1, message: "Profile Fetched Successfully!", status: 200 });
                                objv.execute();
                            }
                            else {
                                let objv = new RawView_1.RawView(res);
                                objv.prepare({ message: "Something Went Wrong List User", status: 502, error: _error });
                                objv.execute();
                            }
                        });
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Something Went Wrong With User", status: 502, error: _error1 });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    subCustomerList(req, res, next) {
        let sdata = req.query;
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            let msg = "";
            if (error == 1) {
                let obj = new RawQuery_1.ModelRawQuery(req, res);
                // if(sessdata.type == '1' || sessdata.type == '12'){
                //     obj.nonqrysql = "select * from user where type='22' AND `idaccount`='"+sdata.idaccount+"'";
                // }
                // else{
                obj.qrysql = "SELECT * FROM `user` WHERE `idaccount`='" + sessdata.idaccount + "'";
                // }
                obj.prepare();
                obj.execute((_error, result) => {
                    if (_error == 1) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ data: result, message: "Sub Customer Fetched!", status: 201 });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ data: result, message: "Something Went Wrong With Connection!", status: 502 });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    updateProfilePic(req, res, next) {
        let filePath;
        if (req.file) {
            const fileName = req.file.filename;
            filePath = req.protocol + '://' + req.get('host') + '/uploads/' + fileName;
        }
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((err, sessdata) => {
            if (err == 1) {
                let obj6 = new RawQuery_1.ModelRawQuery(req, res);
                obj6.qrysql = "UPDATE `user_profile` SET `profile_pic`='" + filePath + "' WHERE `iduser`='" + sessdata.iduser + "'";
                obj6.prepare();
                obj6.execute((_error, result) => {
                    if (_error == 1) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Profile Pic Update Successfully!", data: result, status: 201 });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Something Went Wrong!", status: 502 });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    addBillingAddress(req, res, next) {
        let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let chkdata = [];
                chkdata = req.body.data;
                let obj0 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                obj0.nonqrysql = "SELECT `idaccount` FROM `billing_address` WHERE `idaccount`='" + sessdata.idaccount + "'";
                obj0.prepare();
                obj0.execute((_erro, datachk) => {
                    if (datachk.length > 0) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Your Address Already Exist!", status: 502 });
                        objv.execute();
                    }
                    else {
                        let rdata = [];
                        rdata = req.body.data;
                        let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                        obj.nonqrysql = "INSERT INTO `billing_address` (`idaccount`, `first_name`, `last_name`, `contact`, `email`, `address1`, `address2`, `city`, `state`, `postal_code`, `country`) VALUES ('" + sessdata.idaccount + "', '" + rdata.first_name + "', '" + rdata.last_name + "', '" + rdata.contact + "', '" + rdata.email + "', '" + rdata.address1 + "', '" + rdata.address2 + "', '" + rdata.city + "', '" + rdata.state + "', '" + rdata.postal_code + "', '" + rdata.country + "')";
                        obj.prepare();
                        obj.execute((_error, data) => {
                            if (_error == 1) {
                                let obj4 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                obj4.nonqrysql = "UPDATE `user` SET `isAddress`='true' WHERE `iduser`='" + sessdata.iduser + "'";
                                obj4.prepare();
                                obj4.execute((_error, user) => {
                                    if (_error == 1) {
                                        let obj5 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                        obj5.nonqrysql = "UPDATE `session` SET `isAddress`='true' WHERE `iduser`='" + sessdata.iduser + "'";
                                        obj5.prepare();
                                        obj5.execute((_err, user) => {
                                            if (_err == 1) {
                                                let obj6 = new RawQuery_1.ModelRawQuery(req, res);
                                                obj6.qrysql = "SELECT * FROM `session` WHERE `authkey`='" + sessdata.authkey + "'";
                                                obj6.prepare();
                                                obj6.execute((_sessError, sessData) => {
                                                    if (_sessError == 1) {
                                                        let objv = new RawView_1.RawView(res);
                                                        objv.prepare({ message: "Address Saved Successfully!", session: sessData, data: data, status: 201 });
                                                        objv.execute();
                                                    }
                                                    else {
                                                        let objv = new RawView_1.RawView(res);
                                                        objv.prepare({ message: "Address Saved Successfully Error With Connection!", status: 502 });
                                                        objv.execute();
                                                    }
                                                });
                                            }
                                            else {
                                                let objv = new RawView_1.RawView(res);
                                                objv.prepare({ message: "Address Saved Successfully Error With Connection!", status: 502 });
                                                objv.execute();
                                            }
                                        });
                                    }
                                    else {
                                        let objv = new RawView_1.RawView(res);
                                        objv.prepare({ message: "Address Saved Successfully Error With Connection!", status: 502 });
                                        objv.execute();
                                    }
                                });
                            }
                            else {
                                let objv = new RawView_1.RawView(res);
                                objv.prepare({ message: "Something Went Wrong With Connection!", status: 502 });
                                objv.execute();
                            }
                        });
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    getBillingAddress(req, res, next) {
        let sdata = req.query;
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            let msg = "";
            if (error == 1) {
                let obj = new RawQuery_1.ModelRawQuery(req, res);
                obj.qrysql = "SELECT ba.idbilling_address as id_billing_address, ba.first_name, ba.last_name, ba.address1, ba.address2, ba.city, ba.state, ba.postal_code, ba.country, up.firstname, up.lastname, up.phone, up.email FROM billing_address ba RIGHT JOIN user_profile up ON ba.idaccount= (SELECT idaccount from user where iduser='" + sessdata.iduser + "') WHERE up.`iduser` = '" + sessdata.iduser + "'";
                obj.prepare();
                obj.execute((_error, result) => {
                    if (_error == 1) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({
                            error: 0,
                            data: result,
                            message: msg,
                            status: 200
                        });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({
                            error: result,
                            message: "Something Went Wrong With Connection!",
                            status: 502
                        });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    getInvoice(req, res, next) {
        let sdata = req.query;
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            let msg = "";
            if (error == 1) {
                let obj = new RawQuery_1.ModelRawQuery(req, res);
                obj.qrysql = "SELECT * FROM invoice";
                obj.prepare();
                obj.execute((_error, result) => {
                    if (_error == 1) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({
                            error: 0,
                            data: result,
                            message: msg,
                            status: 200
                        });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({
                            error: result,
                            message: "Something Went Wrong With Connection!",
                            status: 502
                        });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    updateBillingAddress(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, _sessdata) => {
            if (error == 1) {
                let obj2 = new RawQuery_1.ModelRawQuery(req, res);
                let rdata = [];
                rdata = req.body.data;
                // `first_name`='" + rdata.first_name + "', `last_name`='" + rdata.last_name + "', `contact`='" + rdata.contact + "', `email`='" + rdata.email + "',
                obj2.qrysql = "UPDATE `billing_address` SET `address1`='" + rdata.address1 + "', `address2`='" + rdata.address2 + "', `city`='" + rdata.city + "', `state`='" + rdata.state + "', `postal_code`='" + rdata.postal_code + "', `country`='" + rdata.country + "' WHERE `idbilling_address` = '" + rdata.idbilling_address + "'";
                obj2.prepare();
                obj2.execute((error, allcamp) => {
                    if (error == 1) {
                        let obj4 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                        obj4.nonqrysql = "UPDATE `user` SET `isAddress`='true' WHERE `iduser`='" + _sessdata.iduser + "'";
                        obj4.prepare();
                        obj4.execute((_error, user) => {
                            if (_error == 1) {
                                let obj5 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                obj5.nonqrysql = "UPDATE `session` SET `isAddress`='true' WHERE `iduser`='" + _sessdata.iduser + "'";
                                obj5.prepare();
                                obj5.execute((_err, user) => {
                                    if (_err == 1) {
                                        let objv = new RawView_1.RawView(res);
                                        objv.prepare({ message: "Address Updated Successfully!", data: allcamp, session: _sessdata, status: 201 });
                                        objv.execute();
                                    }
                                    else {
                                        let objv = new RawView_1.RawView(res);
                                        objv.prepare({ message: "Address Updated Successfully Error With Connection!", status: 502 });
                                        objv.execute();
                                    }
                                });
                            }
                            else {
                                let objv = new RawView_1.RawView(res);
                                objv.prepare({ message: "Address Updated Successfully Error With Connection!", status: 502 });
                                objv.execute();
                            }
                        });
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({
                            error: error,
                            message: "Something went wrong with Connection!",
                            status: 502
                        });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare("No session data there");
                objv.execute();
            }
        });
    }
    getSupplier(req, res, next) {
        let sdata = req.query;
        if (sdata.type == "detail") {
            super.getMethod(req, res, next);
        }
        else {
            let session = new Session_1.SessionManagment(req, res, next);
            session.GetSession((error, sessdata) => {
                let msg = "";
                if (error == 1) {
                    let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                    obj.nonqrysql = "CALL getSupplier(" + sessdata.iduser + ")";
                    obj.prepare();
                    obj.execute((_error, result) => {
                        if (_error == 1) {
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({ data: result, message: msg, status: 200 });
                            objv.execute();
                        }
                        else {
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({ data: result, message: "Something Went Wrong With Connection!", status: 502 });
                            objv.execute();
                        }
                    });
                }
                else {
                    let objv = new _406_1.Res406(res);
                    objv.prepare(session);
                    objv.execute();
                }
            });
        }
    }
    getSuppliers(req, res, next) {
        let sdata = req.query;
        if (sdata.type == "detail") {
            super.getMethod(req, res, next);
        }
        else {
            let session = new Session_1.SessionManagment(req, res, next);
            session.GetSession((error, _sessdata) => {
                let msg = "";
                if (error == 1) {
                    let obj = new RawQuery_1.ModelRawQuery(req, res);
                    obj.qrysql = "SELECT `username` `value`, `idaccount` `key`, `selected`,`did`, `sms`, `voice` FROM `user` WHERE `type`=3";
                    obj.prepare();
                    obj.execute((_error, result) => {
                        if (_error == 1) {
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({ data: result, message: "Supplier Fatched Successfully!", status: 200 });
                            objv.execute();
                        }
                        else {
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({ error: _error, message: "Something Went Wrong With Connection!", status: 502 });
                            objv.execute();
                        }
                    });
                }
                else {
                    let objv = new _406_1.Res406(res);
                    objv.prepare(session);
                    objv.execute();
                }
            });
        }
    }
    // Upload File
    UploadDocuments(req, res, next) {
        let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
        let sdata = {};
        let session = new Session_1.SessionManagment(req, res, next);
        let msg = "";
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                var sdata = req.body;
                let objfile = new ModelPdfUpload_1.ModelPdfUpload(req, res);
                let fdata = objfile.fileUpload();
                let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                let fileName = fdata[0].replace(/"/g, '\\"').replace(/'/g, "\\'");
                const filePath = req.protocol + '://' + req.get("host") + "/uploads/" + fileName;
                obj.nonqrysql = "INSERT INTO `upload` (`FileName`,`DestinationPath`,`FileType`,`UserID`)VALUES ('" + fileName + "', '" + filePath + "', '" + req.file.mimetype + "','" + sessdata.iduser + "')";
                obj.prepare();
                obj.execute((_error, lastid) => {
                    let objv = new RawView_1.RawView(res);
                    let filepath = req.file.filename + fileName;
                    objv.prepare({ message: "File Uploaded Successfully.", insertedid: lastid.insertId, filename: filepath });
                    objv.execute();
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    /**
     *
     *
     * api
     */
    getCompanyProfile(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let obj = new RawQuery_1.ModelRawQuery(req, res);
                obj.qrysql = "SELECT * FROM `company` WHERE `idaccount`='" + sessdata.idaccount + "'";
                obj.prepare();
                obj.execute((_error, result) => {
                    if (_error == 1) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ data: result, message: "Company Profile Fetched Successfully!", status: 200 });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Something Went Wrong With Connection!", status: 502 });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare("No session data there");
                objv.execute();
            }
        });
    }
    updateCompanyProfile(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let rdata = [];
                rdata = req.body.data;
                if (rdata.idcompany != "") {
                    let obj2 = new RawQuery_1.ModelRawQuery(req, res);
                    obj2.qrysql = "UPDATE `company` SET `company_name`='" + rdata.company_name + "', `ein`='" + rdata.ein + "', `address`='" + rdata.address + "', `city`='" + rdata.city + "', `state`='" + rdata.state + "', `postal_code`='" + rdata.postal_code + "', `website`='" + rdata.website + "', `country`='" + rdata.country[0].name + "', `email`='" + rdata.email + "', `phone`='" + rdata.phone + "' WHERE `idcompany` = '" + rdata.idcompany + "'";
                    obj2.prepare();
                    obj2.execute((error, allcamp) => {
                        if (error == 1) {
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({
                                data: allcamp,
                                message: "Company Profile Updated Successfully!",
                                status: 201
                            });
                            objv.execute();
                        }
                        else {
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({
                                error: error,
                                message: "Something went wrong With Connection!",
                                status: 502
                            });
                            objv.execute();
                        }
                    });
                }
                else {
                    let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                    obj.nonqrysql = "INSERT INTO `company` (`idaccount`, `company_name`, `ein`, `phone`, `email`, `address`, `city`, `state`, `country`, `postal_code`, `website`) VALUES ('" + sessdata.idaccount + "', '" + rdata.company_name + "', '" + rdata.ein + "', '" + rdata.phone + "', '" + rdata.email + "', '" + rdata.address + "', '" + rdata.city + "', '" + rdata.state + "', '" + rdata.country + "', '" + rdata.postal_code + "', '" + rdata.website + "')";
                    obj.prepare();
                    obj.execute((_error, data) => {
                        if (_error == 1) {
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({ message: "Company Profile Saved Successfully!", status: 201 });
                            objv.execute();
                        }
                        else {
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({ message: "Something went wrong With Connection!", status: 502 });
                            objv.execute();
                        }
                    });
                }
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare("No session data there");
                objv.execute();
            }
        });
    }
    ChangePassword(req, res, next) {
        let sdata = JSON.parse(req.body.data);
        if (sdata.old_password == 'undefined' || sdata.old_password == null) {
            let objv = new _406_1.Res406(res);
            objv.prepare({ message: "Password Not Found.", "error": 0 });
            objv.execute();
        }
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let obj0 = new RawQuery_1.ModelRawQuery(req, res);
                obj0.qrysql = "SELECT `password` FROM `user` WHERE `iduser`='" + sessdata.iduser + "' AND `password`='" + sdata.old_password + "'";
                obj0.prepare();
                obj0.execute((_error, result) => {
                    if (result[0] !== undefined) {
                        let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                        obj.nonqrysql = "CALL ChangePassword(" + sessdata.idaccount + ", " + sessdata.iduser + ", '" + sdata.old_password + "','" + sdata.confirm_password + "')";
                        obj.prepare();
                        obj.execute((__error, result) => {
                            if (__error == 1) {
                                let objv = new RawView_1.RawView(res);
                                objv.prepare({
                                    result: result,
                                    message: "Password Changed Successfully!",
                                    status: 201
                                });
                                objv.execute();
                            }
                            else {
                                let objv = new RawView_1.RawView(res);
                                objv.prepare({
                                    _error: _error,
                                    message: "Something Went Wrong With Connection!",
                                    status: 502
                                });
                                objv.execute();
                            }
                        });
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({
                            message: "The old password you have entered is incorrect!",
                            status: 404
                        });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    deleteUserSingleData(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((_error, _sessdata) => {
            let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
            obj.nonqrysql = "delete from user WHERE iduser = '" + req.query.id + "'";
            obj.prepare();
            obj.execute((_error, lastid) => {
                if (_error == 1) {
                    let objv = new RawView_1.RawView(res);
                    objv.prepare({ message: "User Deleted Successfully!", data: lastid[0], status: 201 });
                    objv.execute();
                }
                else {
                    let objv = new RawView_1.RawView(res);
                    objv.prepare({ message: "Something Went Wrong With Connection!", error: _error, status: 502 });
                    objv.execute();
                }
            });
        });
    }
    deleteUser(req, res, next) {
        let sdata = [];
        sdata = req.query.id;
        let dData = JSON.parse(sdata);
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, _sessdata) => {
            if (error == 1) {
                let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                obj.nonqrysql = "CALL DeleteUser('" + dData.idaccount + "', '" + dData.iduser + "')";
                obj.prepare();
                obj.execute((_error, result) => {
                    if (_error == 1) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ data: result, message: "Delete User Successfully!", status: 200 });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ data: result, message: "Something Went Wrong With Connection!", status: 502 });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    // public TaxAuthentication(req: Request, res: Response, next: NextFunction) {
    //     console.log(req.body.data);
    //     let sdata = req.body.data
    //     var request = require('request');
    //     var options = {
    //         'method': 'POST',
    //         'url': sdata.url,
    //         'headers': {
    //             'Content-Type': 'application/json'
    //         },
    //         body: JSON.stringify(sdata.data)
    //     };
    //     request(options, function (error: any, response: any) {
    //         console.log(response.body)
    //         let objv = new RawView(res);
    //         objv.prepare(response.body);
    //         objv.execute();
    //     });
    // }
    TaxCalculation(req, res, _next) {
        let sdata = req.body.data;
        var request = require('request');
        var options = {
            'method': 'POST',
            'url': 'http://localhost/avatax/php/trunk/charges/cal_taxaxtion',
            'headers': {
                'Content-Type': 'application/json',
                'Cookie': 'AuthToken=' + sdata.data.token
            },
            body: JSON.stringify(sdata.data)
        };
        request(options, function (_error, response) {
            let objv = new RawView_1.RawView(res);
            objv.prepare(response.body);
            objv.execute();
        });
    }
    detailsCDR(req, res, next) {
        let sdata = req.query;
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((_error, _sessdata) => {
            let obj = new RawQuery_1.ModelRawQuery(req, res);
            obj.qrysql = "SELECT * FROM cdr WHERE date1 = '" + sdata.from_date + "' AND date2= '" + sdata.to_date + "' AND ani= '" + sdata.from_ani + "' AND did= '" + sdata.to_did + "' AND callid= '" + sdata.call_id + "' ";
            obj.prepare();
            obj.execute((_error, lastid) => {
                let objv = new RawView_1.RawView(res);
                objv.prepare({ message: "Fetched Data Successfully!", data: lastid[0] });
                objv.execute();
            });
        });
    }
    apiToken(req, res, next) {
        const key = Str.random(30);
        var rdata;
        rdata = req.body.data;
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let obj = new RawQuery_1.ModelRawQuery(req, res);
                obj.qrysql = "SELECT * FROM `api` where `name` = '" + rdata.name + "'";
                obj.prepare();
                obj.execute((_error, getConn) => {
                    if (getConn[0]) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({
                            message: "Token Already Exists!",
                            status: 404
                        });
                        objv.execute();
                    }
                    else {
                        let obj5 = new RawQuery_1.ModelRawQuery(req, res);
                        if (sessdata.type == 2) {
                            obj5.qrysql = "INSERT INTO `api` (`idaccount`, `iduser`, `idtariff`, `name`, `key`, `path`) VALUES('" + sessdata.idaccount + "', '" + rdata.user + "', '" + rdata.idtariff + "' ,'" + rdata.name + "', '" + key + "', '" + rdata.status + "')";
                        }
                        else {
                            obj5.qrysql = "INSERT INTO `api` (`idaccount`, `iduser`, `idtariff`, `name`, `key`, `path`) VALUES('" + sessdata.idaccount + "', '" + sessdata.iduser + "', '" + sessdata.idtariff + "' ,'" + rdata.name + "', '" + key + "', '" + rdata.status + "')";
                        }
                        obj5.prepare();
                        obj5.execute((_error, result) => {
                            if (_error == 1) {
                                let objv = new RawView_1.RawView(res);
                                objv.prepare({
                                    data: result,
                                    message: "Token Saved Successfully!",
                                    status: 201
                                });
                                objv.execute();
                            }
                            else {
                                let objv = new RawView_1.RawView(res);
                                objv.prepare({
                                    data: result,
                                    message: "Something Went Wrong With Connection!",
                                    status: 502
                                });
                                objv.execute();
                            }
                        });
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare("No session data there");
                objv.execute();
            }
        });
    }
    getApiToken(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let user;
                let obj5 = new RawQuery_1.ModelRawQuery(req, res);
                if (sessdata.type == 2) {
                    obj5.qrysql = "select * from `api` where `idaccount`='" + sessdata.idaccount + "'";
                }
                else if (sessdata.type == 22) {
                    obj5.qrysql = "select * from `api` where `iduser`='" + sessdata.iduser + "'";
                }
                else {
                    obj5.qrysql = "select * from `api` where `idaccount`='" + sessdata.idaccount + "'";
                }
                obj5.prepare();
                obj5.execute((_error, result) => {
                    if (_error == 1) {
                        if (result.length > 0) {
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({
                                data: result,
                                message: "Token Fetched Successfully!",
                                status: 200
                            });
                            objv.execute();
                        }
                        else {
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({
                                data: result,
                                message: "No Data Found!",
                                status: 404
                            });
                            objv.execute();
                        }
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({
                            data: result,
                            message: "Something Went Wrong With Connection!",
                            status: 502
                        });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare("No session data there");
                objv.execute();
            }
        });
    }
    deleteApiToken(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, _sessdata) => {
            if (error == 1) {
                let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                obj.nonqrysql = "delete from `api` WHERE `idapi` = '" + req.query.id + "'";
                obj.prepare();
                obj.execute((_error, result) => {
                    if (_error == 1) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Api Key Deleted Successfully!", data: result, status: 201 });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Something Went Wrong With Connection!", data: result, status: 502 });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare("No session data there");
                objv.execute();
            }
        });
    }
    saveTheme(req, res, next) {
        var rdata = [];
        rdata = req.body.data;
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let obj2 = new RawQuery_1.ModelRawQuery(req, res);
                obj2.filter = null;
                obj2.qrysql = "INSERT into `theme` (`idaccount`, `brandName`, `domain`, `customLogo`, `email`, `phone`, `support_url`, `header_color`, `navbar_color`, `sidebar_color`, `ssl_certificate`, `ssl_key`) VALUES('" + sessdata.idaccount + "', '" + rdata.brandName + "', '" + rdata.domain + "', '" + rdata.custom_logo + "', '" + rdata.email + "', '" + rdata.phone + "', '" + rdata.support_url + "', '" + rdata.header_color + "', '" + rdata.navbar_color + "', '" + rdata.sidebar_color + "', '" + rdata.ssl_certificate + "', '" + rdata.ssl_key + "')";
                obj2.prepare();
                obj2.execute((_error, result) => {
                    if (result) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ data: result, message: "Theme Saved Successfully!" });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Something Went Successfully!" });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare("No Session Data There");
                objv.execute();
            }
        });
    }
    updateTheme(req, res, next) {
        let filePath;
        let rdata = [];
        rdata = JSON.parse(req.body.data);
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                if (req.file) {
                    const fileName = req.file.filename;
                    filePath = "https://api.signalmash.com/uploads/" + fileName;
                }
                else if (rdata.logo == undefined || rdata.logo == null) {
                    filePath = "./assets/img/logo.png";
                }
                let obj2 = new RawQuery_1.ModelRawQuery(req, res);
                obj2.filter = null;
                obj2.qrysql = "UPDATE `theme` SET `brandName`='" + rdata.brandName + "', `domain`='" + rdata.domain + "', `customLogo`='" + filePath + "', `email`='" + rdata.email + "', `phone`='" + rdata.phone + "', `support_url`='" + rdata.support_url + "', `header_color`='" + rdata.header_color + "', `navbar_color`='" + rdata.navbar_color + "', `sidebar_color`='" + rdata.sidebar_color + "', `ssl_certificate`='" + rdata.ssl_certificate + "', `ssl_key`='" + rdata.ssl_key + "' WHERE `id_theme`='" + rdata.id_theme + "'";
                obj2.prepare();
                obj2.execute((error, allcamp) => {
                    let objv = new RawView_1.RawView(res);
                    objv.prepare({
                        error: 0,
                        data: allcamp,
                        message: "Theme Updated Successfully"
                    });
                    objv.execute();
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare("No session data there");
                objv.execute();
            }
        });
    }
    getThemes(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((_error, sessdata) => {
            let obj = new RawQuery_1.ModelRawQuery(req, res);
            obj.qrysql = "SELECT * FROM `theme` WHERE `idaccount` = '" + sessdata.idaccount + "'";
            obj.prepare();
            obj.execute((_error, result) => {
                if (result.length > 0) {
                    let objv = new RawView_1.RawView(res);
                    objv.prepare({ message: "Theme data Fetched!", data: result });
                    objv.execute();
                }
                else {
                    let objv = new RawView_1.RawView(res);
                    objv.prepare({ message: "NO Data Found!" });
                    objv.execute();
                }
            });
        });
    }
    getTheme(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((_error, sessdata) => {
            let obj = new RawQuery_1.ModelRawQuery(req, res);
            obj.qrysql = "select * from theme where id_theme='" + req.query.type + "' AND idaccount = '" + sessdata.idaccount + "'";
            obj.prepare();
            obj.execute((_error, result) => {
                if (_error == 1) {
                    let objv = new RawView_1.RawView(res);
                    objv.prepare({ message: "Theme data Fetched!", data: result });
                    objv.execute();
                }
                else {
                    let objv = new RawView_1.RawView(res);
                    objv.prepare({ message: "Something Went Wrong!" });
                    objv.execute();
                }
            });
        });
    }
    deleteTheme(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((_error, sessdata) => {
            let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
            obj.nonqrysql = "delete from `theme` WHERE `id_theme` = '" + req.query.id + "' AND idaccount = '" + sessdata.idaccount + "'";
            obj.prepare();
            obj.execute((_error, result) => {
                let objv = new RawView_1.RawView(res);
                objv.prepare({ message: "Theme Deleted Successfully!", data: result });
                objv.execute();
            });
        });
    }
    saveOtp(req, res, next) {
        let sdata = req.body;
        let otp = Math.floor(100000 + Math.random() * 900000);
        sdata.otp = otp;
        // sdata.BODY = sdata.BODY + otp;
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let obj4 = new RawQuery_1.ModelRawQuery(req, res);
                obj4.qrysql = "SELECT * FROM `user_profile` WHERE `iduser`='" + sessdata.iduser + "'";
                obj4.prepare();
                obj4.execute((_error, user) => {
                    let getUser = user[0];
                    if (error == 1) {
                        let obj5 = new RawQuery_1.ModelRawQuery(req, res);
                        obj5.qrysql = "SELECT * FROM `sms_template` WHERE type='mobile_verification'";
                        obj5.prepare();
                        obj5.execute((emlErr, emlRes) => {
                            if (emlErr == 1 && emlRes.length > 0) {
                                let BODY = emlRes[0].body;
                                BODY = BODY.replace(/{FIRST_NAME}/g, getUser.firstname);
                                BODY = BODY.replace(/{LAST_NAME}/g, getUser.lastname);
                                BODY = BODY.replace(/{OTP}/g, sdata.otp);
                                var headers = {
                                    'accept': '*/*',
                                    'Content-Type': 'application/x-www-form-urlencoded'
                                };
                                var dataString = 'Username=Gventure_test&Password=qzcLAGsUh-V8J57xNrFOJiBpZQCHEz';
                                var options = {
                                    url: 'https://api.signalmash.com/apilogin',
                                    method: 'POST',
                                    headers: headers,
                                    body: dataString
                                };
                                request(options, (login_error, login_resp) => {
                                    let auth_key;
                                    let key = Str.random(30);
                                    if (login_resp !== undefined) {
                                        let data = JSON.parse(login_resp.body);
                                        auth_key = data.session;
                                        var headers = {
                                            'accept': '*/*',
                                            'Authorization': auth_key,
                                            'Content-Type': 'application/x-www-form-urlencoded'
                                        };
                                        var dataString = 'FROM=' + sdata.FROM.trim() + '&TO=' + sdata.TO.trim() + '&BODY=' + BODY + '&Connection=&OutboundSMS=';
                                        var options = {
                                            url: 'https://api.signalmash.com/sms',
                                            method: 'POST',
                                            headers: headers,
                                            body: dataString
                                        };
                                        // url: 'https://api.signalmash.com/sms',
                                        request(options, (sms_err, sms_responce) => {
                                            let sms_resp = JSON.parse(sms_responce.body);
                                            if (sms_resp.status == 201) {
                                                let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                                obj.nonqrysql = "INSERT INTO `two_factor_auth` (`iduser`, `otp`, `from`, `to`, `session_id`) VALUES('" + sessdata.iduser + "', '" + sdata.otp + "', '" + sdata.FROM + "', '" + sdata.TO + "', '" + key + "')";
                                                obj.prepare();
                                                obj.execute((mdr_err, mdr_resp) => {
                                                    if (mdr_err == 1) {
                                                        let obj = new RawView_1.RawView(res);
                                                        obj.prepare({ result: "Success", data: mdr_resp, message: "OTP Sent Successfully", status: 201 });
                                                        obj.execute();
                                                    }
                                                    else {
                                                        let obj = new RawView_1.RawView(res);
                                                        obj.prepare({ result: "Failed", message: "Something Went Wrong with Connection!", status: 502 });
                                                        obj.execute();
                                                    }
                                                });
                                            }
                                            else {
                                                let obj = new RawView_1.RawView(res);
                                                obj.prepare({ message: sms_resp.message, status: 503 });
                                                obj.execute();
                                            }
                                        });
                                    }
                                    else {
                                        let obj = new RawView_1.RawView(res);
                                        obj.prepare({ message: login_error, status: 502 });
                                        obj.execute();
                                    }
                                });
                            }
                            else {
                                let objv = new _406_1.Res406(res);
                                objv.prepare("SMS Template not Fateched Successfully!");
                                objv.execute();
                            }
                        });
                    }
                    else {
                        let objv = new _406_1.Res406(res);
                        objv.prepare("User not Fateched Successfully!");
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare("No session data there");
                objv.execute();
            }
        });
    }
    verifyOtp(req, res, next) {
        let sdata = req.body;
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((err, sessdata) => {
            let obj = new RawQuery_1.ModelRawQuery(req, res);
            obj.qrysql = "SELECT `otp` FROM `two_factor_auth` WHERE `iduser` = '" + sessdata.iduser + "' AND `otp`='" + sdata.otp + "' AND UNIX_TIMESTAMP()-UNIX_TIMESTAMP(created)<300";
            obj.prepare();
            obj.execute((error, getEmail) => {
                if (error == 1) {
                    if (getEmail.length > 0) {
                        let obj1 = new RawQuery_1.ModelRawQuery(req, res);
                        obj1.qrysql = "UPDATE `user` SET `isEmailVerify`= 'true', `isMobileVerify`='true' WHERE `iduser`='" + sessdata.iduser + "'";
                        obj1.prepare();
                        obj1.execute((_error, success) => {
                            if (_error == 1) {
                                let obj5 = new RawQuery_1.ModelRawQuery(req, res);
                                obj5.qrysql = "UPDATE `session` SET `isMobileVerify`='true' WHERE `iduser`='" + sessdata.iduser + "'";
                                obj5.prepare();
                                obj5.execute((_sessErr, sessRes) => {
                                    if (_sessErr == 1) {
                                        let obj6 = new RawQuery_1.ModelRawQuery(req, res);
                                        obj6.qrysql = "UPDATE `user_profile` SET `phone`='" + sdata.TO + "' WHERE `iduser`='" + sessdata.iduser + "'";
                                        obj6.prepare();
                                        obj6.execute((_sessError, sessData) => {
                                            if (_sessError == 1) {
                                                let obj7 = new RawQuery_1.ModelRawQuery(req, res);
                                                obj7.qrysql = "SELECT * FROM `session` WHERE `authkey`='" + sessdata.authkey + "'";
                                                obj7.prepare();
                                                obj7.execute((sError, sData) => {
                                                    if (sError == 1) {
                                                        let objv = new RawView_1.RawView(res);
                                                        objv.prepare({
                                                            message: "OTP Verified!",
                                                            status: 200,
                                                            session: sData
                                                        });
                                                        objv.execute();
                                                    }
                                                    else {
                                                        let objv = new RawView_1.RawView(res);
                                                        objv.prepare({
                                                            message: "OTP Verified Error With Connection!",
                                                            status: 502
                                                        });
                                                        objv.execute();
                                                    }
                                                });
                                            }
                                            else {
                                                let objv = new RawView_1.RawView(res);
                                                objv.prepare({
                                                    message: "Mobile Number Not Verified!",
                                                    status: 500
                                                });
                                                objv.execute();
                                            }
                                        });
                                    }
                                    else {
                                        let objv = new RawView_1.RawView(res);
                                        objv.prepare({
                                            errMessage: "Mobile Number Not Verified!",
                                            status: 502
                                        });
                                        objv.execute();
                                    }
                                });
                            }
                            else {
                                let objv = new RawView_1.RawView(res);
                                objv.prepare({
                                    message: "Mobile Number Not Verified!",
                                    status: 502
                                });
                                objv.execute();
                            }
                        });
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({
                            message: "You Have Enter Wrong OTP!",
                            status: 502
                        });
                        objv.execute();
                    }
                }
                else {
                    let objv = new RawView_1.RawView(res);
                    objv.prepare({
                        message: "Something Went Wrong With Connection!",
                        status: 502
                    });
                    objv.execute();
                }
            });
        });
    }
    resendEmail(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((err, sessdata) => {
            if (err == 1) {
                let secret = Str.random(15);
                let validationKey = jwt.sign({
                    exp: Math.floor(Date.now() / 1000) + (60 * 60),
                    data: sessdata.email + sessdata.password
                }, secret);
                let obj3 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                obj3.nonqrysql = "UPDATE `user` SET `validationKey`='" + validationKey + "', `secret`='" + secret + "' WHERE `iduser`='" + sessdata.iduser + "'";
                obj3.prepare();
                obj3.execute((_err, __result) => {
                    if (_err == 1) {
                        let obj4 = new RawQuery_1.ModelRawQuery(req, res);
                        obj4.qrysql = "SELECT * FROM `user_profile` WHERE `iduser`='" + sessdata.iduser + "'";
                        obj4.prepare();
                        obj4.execute((_error, user) => {
                            let getUser = user[0];
                            if (_err == 1) {
                                let obj5 = new RawQuery_1.ModelRawQuery(req, res);
                                obj5.qrysql = "SELECT * FROM `email_template` WHERE type='email_verification'";
                                obj5.prepare();
                                obj5.execute((emlErr, emlRes) => {
                                    if (emlErr == 1) {
                                        if (emlRes.length > 0) {
                                            let tmpData = emlRes[0].template;
                                            tmpData = tmpData.replace(/{FIRST_NAME}/g, getUser.firstname);
                                            tmpData = tmpData.replace(/{LAST_NAME}/g, getUser.lastname);
                                            tmpData = tmpData.replace(/{VALIDATION_KEY}/g, validationKey);
                                            var smtpTransport = nodemailer.createTransport({
                                                service: "gmail",
                                                host: "smtp.gmail.com",
                                                port: 587,
                                                secure: true,
                                                auth: {
                                                    user: "donotreply@nglcommunications.com",
                                                    pass: "yr%5V9GB"
                                                }
                                            });
                                            var mailOptions = {
                                                from: 'Signalmash <donotreply@signalmash.com>',
                                                to: getUser.email,
                                                usernmae: getUser.username,
                                                email: getUser.email,
                                                subject: `${emlRes[0].subject}`,
                                                text: "Thank You For Registration",
                                                html: `${tmpData}`
                                            };
                                            smtpTransport.sendMail(mailOptions, (_emailError, emailRes) => {
                                                if (_emailError) {
                                                    let objv = new RawView_1.RawView(res);
                                                    objv.prepare({ status: 401, errMessage: "Opps Email Not Sent!", error: _emailError });
                                                    objv.execute();
                                                }
                                                else {
                                                    let objv = new RawView_1.RawView(res);
                                                    objv.prepare({ iduser: sessdata.iduser, status: 201, data: emailRes, message: "Email Send Succesfully!" });
                                                    objv.execute();
                                                }
                                            });
                                        }
                                        else {
                                            let objv = new RawView_1.RawView(res);
                                            objv.prepare({ status: 401, errMessage: "Templating Data Not Found!" });
                                            objv.execute();
                                        }
                                    }
                                    else {
                                        let objv = new RawView_1.RawView(res);
                                        objv.prepare({ errMessage: "Something Went Wrong with DB!", status: 502 });
                                        objv.execute();
                                    }
                                });
                            }
                            else {
                                let objv = new RawView_1.RawView(res);
                                objv.prepare({ errMessage: "Something Went Wrong with DB!", status: 502 });
                                objv.execute();
                            }
                        });
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ errMessage: "Something Went Wrong with DB!", status: 502 });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    updateTariff(req, res, next) {
        let sdata = req.body.data;
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((err, sessdata) => {
            if (err == 1) {
                let obj4 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                obj4.nonqrysql = "UPDATE `user` LEFT JOIN `account` ON `user`.`idaccount`=`account`.`idaccount` SET `idtariff`='" + sdata.tariff1 + "', `idtariff1`='" + sdata.tariff1 + "', `isPlan`='true' WHERE `iduser`='" + sessdata.iduser + "'";
                obj4.prepare();
                obj4.execute((_error, user) => {
                    if (_error == 1) {
                        let obj5 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                        obj5.nonqrysql = "UPDATE `session` SET `isPlan`='true', `idtariff`='" + sdata.tariff1 + "' WHERE `iduser`='" + sessdata.iduser + "'";
                        obj5.prepare();
                        obj5.execute((_err, user) => {
                            if (_err == 1) {
                                let currSess = server_1.sessiondata.get(req.headers.authorization);
                                currSess.idtariff = sdata.tariff1;
                                currSess.isPlan = "true";
                                server_1.sessiondata.set(req.headers.authorization, currSess);
                                let obj6 = new RawQuery_1.ModelRawQuery(req, res);
                                obj6.qrysql = "SELECT * FROM `session` WHERE `authkey`='" + sessdata.authkey + "'";
                                obj6.prepare();
                                obj6.execute((seserr, sessionData) => {
                                    if (seserr == 1) {
                                        let objv = new RawView_1.RawView(res);
                                        objv.prepare({ message: "Tariff Updated Successfully!", status: 201, session: sessionData });
                                        objv.execute();
                                    }
                                    else {
                                        let objv = new RawView_1.RawView(res);
                                        objv.prepare({ message: "Tariff Updated Error With Connection!", status: 502, error: sessionData });
                                        objv.execute();
                                    }
                                });
                            }
                            else {
                                let objv = new RawView_1.RawView(res);
                                objv.prepare({ message: "Tariff Updated Error With Connection! ", status: 502 });
                                objv.execute();
                            }
                        });
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Something Went Wrong With Connection!", status: 502 });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    currentSession(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((err, sessdata) => {
            if (err == 1) {
                let obj = new RawQuery_1.ModelRawQuery(req, res);
                obj.qrysql = "SELECT * FROM `session` WHERE `authkey`='" + req.query.authkey + "'";
                obj.prepare();
                obj.execute((_error, result) => {
                    if (_error == 1) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Session Fetched Successfully!", status: 200, session: result });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Session Not Fetched DB Error!", status: 502, error: sessdata });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new RawView_1.RawView(res);
                objv.prepare({ message: "Invalid Session Trying to access", status: 401 });
                objv.execute();
            }
        });
    }
    /**
     * To get the list of TimeZones
     */
    GetTimeZones(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let objv = new RawView_1.RawView(res);
                let obj = new RawQuery_1.ModelRawQuery(req, res);
                obj.qrysql = "SELECT id, label utc FROM `tbl_timezones`;";
                obj.prepare();
                obj.execute((_error, result) => {
                    if (error == 1) {
                        result = result || [];
                        objv.prepare({
                            error: 0,
                            message: "Records fetched successfully.",
                            data: result
                        });
                        objv.execute();
                    }
                    else {
                        objv.prepare({
                            error: 1,
                            message: "Something Went Wrong!"
                        });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare("No session data there");
                objv.execute();
            }
        });
    }
    /**
     * To get the user's TimeZone
     */
    GetUserTimeZone(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let iduser = sessdata.iduser;
                let iQry = "SELECT a.id, a.id_timezone, b.label utc FROM `tbl_timezone_config` a\n";
                iQry += "INNER JOIN `tbl_timezones` b ON b.id=a.id_timezone\n";
                iQry += "WHERE a.id_user=" + iduser + ";";
                let objv = new RawView_1.RawView(res);
                let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                obj.nonqrysql = iQry;
                obj.prepare();
                obj.execute((_error, result) => {
                    if (error == 1) {
                        result = Array.isArray(result) && result.length > 0 ? result[0] : null;
                        objv.prepare({
                            error: 0,
                            message: "Record fetched successfully.",
                            data: result
                        });
                        objv.execute();
                    }
                    else {
                        objv.prepare({
                            error: 1,
                            message: "Something Went Wrong!"
                        });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare("No session data there");
                objv.execute();
            }
        });
    }
    /**
     * To update the user's TimeZone
     */
    UpdateUserTimeZone(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let rdata = req.body.data;
                let objv = new RawView_1.RawView(res);
                if (typeof rdata.timezone != 'undefined' && rdata.timezone) {
                    let obj1 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                    obj1.nonqrysql = "REPLACE INTO `tbl_timezone_config`(id_timezone, id_user) VALUES(" + rdata.timezone + ", " + sessdata.iduser + ");";
                    obj1.prepare();
                    obj1.execute((error, result) => {
                        if (error == 1) {
                            /**
                             * Update the TimeZone in user's session data
                             */
                            let obj2 = new RawQuery_1.ModelRawQuery(req, res);
                            obj2.qrysql = "SELECT a.utc client_time FROM tbl_timezones a WHERE a.id=" + rdata.timezone + ";";
                            obj2.prepare();
                            obj2.execute((error, result) => {
                                if (error == 1 && Array.isArray(result) && result.length > 0) {
                                    let obj3 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                    obj3.nonqrysql = "UPDATE `session` SET `client_time`='" + result[0].client_time + "' WHERE `authkey`='" + sessdata.authkey + "';";
                                    obj3.prepare();
                                    obj3.execute((error, result2) => {
                                        sessdata.client_time = result[0].client_time;
                                        server_1.sessiondata.set(sessdata.authkey, sessdata);
                                    });
                                }
                            });
                            objv.prepare({
                                error: 0,
                                message: "Successfully saved."
                            });
                            objv.execute();
                        }
                        else {
                            objv.prepare({
                                error: 1,
                                message: "Something Went Wrong!"
                            });
                            objv.execute();
                        }
                    });
                }
                else {
                    objv.prepare({
                        error: 1,
                        message: "Invalid data!"
                    });
                    objv.execute();
                }
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare("No session data there");
                objv.execute();
            }
        });
    }
    /**************************
    *  Forgot Password start  *
    **************************/
    sendMailForForgetPass(req, res, next) {
        let email = req.query.type;
        let obj = new RawQuery_1.ModelRawQuery(req, res);
        obj.qrysql = "SELECT us.email, us.firstname, us.lastname, u.username FROM user_profile us JOIN `user` u ON us.iduser=u.iduser WHERE us.`email`='" + email + "' ";
        obj.prepare();
        obj.execute((_error, user) => {
            if (_error == 1) {
                if (user.length > 0) {
                    let getUser = user[0];
                    let obj4 = new RawQuery_1.ModelRawQuery(req, res);
                    obj4.qrysql = "SELECT * FROM `email_template` WHERE type='forgot_password'";
                    obj4.prepare();
                    obj4.execute((emlErr, emlRes) => {
                        if (emlErr == 1) {
                            if (emlRes.length > 0) {
                                let secret = Str.random(15);
                                let validationKey = jwt.sign({
                                    exp: Math.floor(Date.now() / 1000) + (60 * 60),
                                    data: email
                                }, secret);
                                let obj3 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                obj3.nonqrysql = "UPDATE `user` SET `validationKey`='" + validationKey + "',`isResetPassword` = 'true'  WHERE `username`='" + getUser.username + "'";
                                obj3.prepare();
                                obj3.execute((_uperr, __result) => {
                                    if (_uperr == 1) {
                                        let tmpData = emlRes[0].template;
                                        tmpData = tmpData.replace(/{FIRST_NAME}/g, getUser.firstname);
                                        tmpData = tmpData.replace(/{LAST_NAME}/g, getUser.lastname);
                                        tmpData = tmpData.replace(/{VALIDATION_KEY}/g, validationKey);
                                        var smtpTransport = nodemailer.createTransport({
                                            service: "gmail",
                                            host: "smtp.gmail.com",
                                            port: 587,
                                            secure: true,
                                            auth: {
                                                user: "donotreply@nglcommunications.com",
                                                pass: "yr%5V9GB"
                                            }
                                        });
                                        var mailOptions = {
                                            from: 'Signalmash <donotreply@signalmash.com>',
                                            to: getUser.email,
                                            usernmae: getUser.username,
                                            email: getUser.email,
                                            subject: `${emlRes[0].subject}`,
                                            text: "Thank You For Registration",
                                            html: `${tmpData}`
                                        };
                                        smtpTransport.sendMail(mailOptions, (_emailError, emailRes) => {
                                            if (_emailError) {
                                                let objv = new RawView_1.RawView(res);
                                                objv.prepare({ status: 401, message: "Opps Email Not Sent!", error: _emailError });
                                                objv.execute();
                                            }
                                            else {
                                                let objv = new RawView_1.RawView(res);
                                                objv.prepare({ status: 201, message: "Email Send Succesfully! Please Check Your Mail And Verify It.", emailRes });
                                                objv.execute();
                                            }
                                        });
                                    }
                                    else {
                                        let objv = new RawView_1.RawView(res);
                                        objv.prepare({ message: "Something went Wrong!", status: 502 });
                                        objv.execute();
                                    }
                                });
                            }
                            else {
                                let objv = new RawView_1.RawView(res);
                                objv.prepare({ message: "Verification Email not Send!", status: 502 });
                                objv.execute();
                            }
                        }
                        else {
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({ message: "Error With Fetching Email Data!", status: 502 });
                            objv.execute();
                        }
                    });
                }
                else {
                    let objv = new RawView_1.RawView(res);
                    objv.prepare({ status: 404, message: "Email Not Found!" });
                    objv.execute();
                }
            }
            else {
                let objv = new RawView_1.RawView(res);
                objv.prepare({ status: 502, message: "Something Went Wrong to Fetch Email!" });
                objv.execute();
            }
        });
    }
    VerifyToken(req, res, next) {
        let key = req.query.type;
        let obj = new RawQuery_1.ModelRawQuery(req, res);
        obj.qrysql = "SELECT * FROM `user` WHERE validationKey='" + key + "'";
        obj.prepare();
        obj.execute((error, result) => {
            if (result.length > 0) {
                if (result[0].isResetPassword == 'true') {
                    if (error == 1 && result.length > 0) {
                        let obj4 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                        obj4.nonqrysql = "UPDATE `user` SET `isResetPassword`='false' WHERE validationKey='" + key + "'";
                        obj4.prepare();
                        obj4.execute((emlErr, emlRes) => {
                            if (emlErr == 1) {
                                let objv = new RawView_1.RawView(res);
                                objv.prepare({ error: 0, status: 201, message: "Successfull Verified Please Enter Your New Password!", data: result });
                                objv.execute();
                            }
                            else {
                                let objv = new RawView_1.RawView(res);
                                objv.prepare({ error: 0, status: 502, message: "Successfull Verified Status Not Changed!", data: result });
                                objv.execute();
                            }
                        });
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ error: 1, status: 502, message: "Something Went Wrong!" });
                        objv.execute();
                    }
                }
                else {
                    let objv = new RawView_1.RawView(res);
                    objv.prepare({ error: 1, status: 502, message: "The Link You Followed Has Expired!" });
                    objv.execute();
                }
            }
            else {
                let objv = new RawView_1.RawView(res);
                objv.prepare({ error: 1, status: 404, message: "Invalid Account Setting!" });
                objv.execute();
            }
        });
    }
    updatePassword(req, res, next) {
        let alldata = req.body.data;
        let obj0 = new RawNonQuery_1.ModelRawNonQuery(req, res);
        obj0.nonqrysql = "UPDATE `user` SET `password`='" + alldata.password + "',`isResetPassword`='true' WHERE `validationKey`= '" + alldata.key + "'";
        obj0.prepare();
        obj0.execute((error, result) => {
            if (error == 1) {
                let objv0 = new RawView_1.RawView(res);
                objv0.prepare({
                    error: 0,
                    status: 201,
                    message: "Successfully Updated."
                });
                objv0.execute();
            }
            else {
                let objv0 = new RawView_1.RawView(res);
                objv0.prepare({
                    error: 1,
                    status: 502,
                    message: "Something Went Wrong!"
                });
                objv0.execute();
            }
        });
    }
}
exports.UserManagement = UserManagement;
class TZ {
    /**
     * To create the default TimeZone of user
     */
    CreateTZ(req, res, next, callback) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let obj1 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                obj1.nonqrysql = "REPLACE INTO `tbl_timezone_config`(id_timezone, id_user) VALUES(192, " + sessdata.iduser + ");";
                obj1.prepare();
                obj1.execute((error, result) => {
                    if (error == 1) {
                        /**
                         * Update the TimeZone in user's session data
                         */
                        let obj2 = new RawQuery_1.ModelRawQuery(req, res);
                        obj2.qrysql = "SELECT a.utc client_time FROM tbl_timezones a WHERE a.id=192;";
                        obj2.prepare();
                        obj2.execute((error, result) => {
                            if (error == 1 && Array.isArray(result) && result.length > 0) {
                                let obj3 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                obj3.nonqrysql = "UPDATE `session` SET `client_time`='" + result[0].client_time + "' WHERE `authkey`='" + sessdata.authkey + "';";
                                obj3.prepare();
                                obj3.execute((error, result2) => {
                                    sessdata.client_time = result[0].client_time;
                                    server_1.sessiondata.set(sessdata.authkey, sessdata);
                                    callback(error, result);
                                });
                            }
                            else {
                                callback(error, result);
                            }
                        });
                    }
                    else {
                        callback(error, result);
                    }
                });
            }
            else {
                callback(error, "No session data there");
            }
        });
    }
}
exports.TZ = TZ;
