"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.VariableParse = void 0;
class VariableParse {
    EmailInsurance(tempdata, callback) {
        let email_body = tempdata.template;
        let leaddata = tempdata.cdata;
        email_body = email_body.replace(/{FIRST_NAME}/g, leaddata.first_name);
        email_body = email_body.replace(/{LAST_NAME}/g, leaddata.last_name);
        email_body = email_body.replace(/{SPOUSE_FULL_NAME}/g, leaddata.spouse_full_name);
        email_body = email_body.replace(/{STREET_ADDRESS_1}/g, leaddata.street_address_1);
        email_body = email_body.replace(/{STREET_ADDRESS_2}/g, leaddata.street_address_2);
        email_body = email_body.replace(/{CITY}/g, leaddata.city);
        email_body = email_body.replace(/{STATE}/g, leaddata.state);
        email_body = email_body.replace(/{ZIP}/g, leaddata.zip);
        email_body = email_body.replace(/{COUNTY}/g, leaddata.county);
        email_body = email_body.replace(/{APPOINTMENT_DATE}/g, leaddata.date);
        email_body = email_body.replace(/{APPOINTMENTS_DATE}/g, leaddata.date);
        email_body = email_body.replace(/{APPOINTMENT_TIME}/g, leaddata.from_or_contact_time + "-" + leaddata.to_or_agent_time);
        email_body = email_body.replace(/{APPOINTMENT_START_TIME}/g, leaddata.from_or_contact_time);
        email_body = email_body.replace(/{APPOINTMENT_END_TIME}/g, leaddata.to_or_agent_time);
        email_body = email_body.replace(/{APPOINTMENT_COMMENTS}/g, leaddata.comments);
        if (leaddata.place) {
            email_body = email_body.replace(/{APPOINTMENT_PLACE}/g, leaddata.place);
            email_body = email_body.replace(/{ZOOM}/g, leaddata.place);
        }
        else {
            email_body = email_body.replace(/{APPOINTMENT_PLACE}/g, " ");
            email_body = email_body.replace(/{ZOOM}/g, " ");
        }
        email_body = email_body.replace(/{PHONE}/g, leaddata.phone);
        email_body = email_body.replace(/{CELL_PHONE}/g, leaddata.cell_phone);
        email_body = email_body.replace(/{WORK_PHONE}/g, leaddata.work_phone);
        email_body = email_body.replace(/{EMAIL}/g, leaddata.email);
        email_body = email_body.replace(/{BIRTH_DATE}/g, leaddata.birth_date);
        email_body = email_body.replace(/{AGE}/g, leaddata.age);
        email_body = email_body.replace(/{HEIGHT}/g, leaddata.height);
        email_body = email_body.replace(/{WEIGHT}/g, leaddata.weight);
        email_body = email_body.replace(/{SMOKER}/g, leaddata.smoker);
        email_body = email_body.replace(/{SPOUSE_BIRTH_DATE}/g, leaddata.spouse_birth_date);
        email_body = email_body.replace(/{SPOUSE_AGE}/g, leaddata.spouse_age);
        email_body = email_body.replace(/{SPOUSE_HEIGHT}/g, leaddata.spouse_height);
        email_body = email_body.replace(/{SPOUSE_WEIGHT}/g, leaddata.spouse_weight);
        email_body = email_body.replace(/{SPOUSE_SMOKER}/g, leaddata.spouse_smoker);
        email_body = email_body.replace(/{HEALTH_ISSUE}/g, leaddata.health_issue);
        email_body = email_body.replace(/{SPOUSE_HEALTH_ISSUE}/g, leaddata.spouse_health_issue);
        email_body = email_body.replace(/{OCCUPATION}/g, leaddata.occupation);
        email_body = email_body.replace(/{SPOUSE_OCCUPATION}/g, leaddata.spouse_occupation);
        email_body = email_body.replace(/{MORTGAGE_AMOUNT}/g, leaddata.mortgage_amount);
        email_body = email_body.replace(/{MORTGAGE_TERM}/g, leaddata.mortgage_term);
        email_body = email_body.replace(/{HOME_VALUE}/g, leaddata.home_value);
        email_body = email_body.replace(/{LENDER}/g, leaddata.lender);
        email_body = email_body.replace(/{MONTHLY_MORTAGE_PAYMENT}/g, leaddata.monthly_mortage_payment);
        email_body = email_body.replace(/{PURCHASE_REFI}/g, leaddata.purchase_refi);
        email_body = email_body.replace(/{BENEFICIARY}/g, leaddata.beneficiary);
        email_body = email_body.replace(/{ASSIGN_DATE}/g, leaddata.assign_date);
        email_body = email_body.replace(/{SALSE_REP_NAME}/g, leaddata.salse_rep_name);
        email_body = email_body.replace(/{STATUS}/g, leaddata.status);
        email_body = email_body.replace(/{LEAD_LEVEL}/g, leaddata.lead_level);
        email_body = email_body.replace(/{REFERRER}/g, leaddata.referrer);
        email_body = email_body.replace(/{COMMENTS}/g, leaddata.comments);
        email_body = email_body.replace(/{PDF}/g, leaddata.pdf);
        email_body = email_body.replace(/{FIELD1}/g, leaddata.field1);
        email_body = email_body.replace(/{FIELD2}/g, leaddata.field2);
        email_body = email_body.replace(/{FIELD3}/g, leaddata.field3);
        email_body = email_body.replace(/{FIELD4}/g, leaddata.field4);
        email_body = email_body.replace(/{FIELD5}/g, leaddata.field5);
        email_body = email_body.replace(/{FIELD6}/g, leaddata.field6);
        email_body = email_body.replace(/{AGENT_FIRSTNAME}/g, tempdata.agfirst_name);
        email_body = email_body.replace(/{AGENT_LASTNAME}/g, tempdata.aglast_name);
        email_body = email_body.replace(/{AGENT_CONTACT}/g, tempdata.agcontact);
        email_body = email_body.replace(/{AGENT_EMAIL}/g, tempdata.agemail);
        email_body = email_body.replace(/{AGENT_FULLNAME}/g, tempdata.agfirst_name + " " + tempdata.aglast_name);
        /** spinner variable replacement **/
        if (email_body) {
            let qualityRegex = /\[[^\]]*\]/g, matches, qualities = [], spinner = [];
            while (matches = qualityRegex.exec(email_body)) {
                qualities.push(decodeURIComponent(matches));
            }
            if (qualities && Array.isArray(qualities)) {
                qualities.forEach(function (value, key) {
                    let n_value = value.replace(/[\[\]']+/g, '');
                    n_value = n_value.split('|');
                    spinner.push(n_value[Math.floor(Math.random() * n_value.length)]);
                });
            }
            let r_str = email_body;
            if (email_body.indexOf("&#91;")) {
                r_str = r_str.replace(/\[/g, '&#91;');
            }
            if (email_body.indexOf("&#93;")) {
                r_str = r_str.replace(/\]/g, '&#93;');
            }
            if (email_body.indexOf("&#124;")) {
                r_str = r_str.replace(/\|/g, '&#124;');
            }
            email_body = r_str;
            if (spinner && Array.isArray(spinner)) {
                spinner.forEach(function (value, key) {
                    let n_key = qualities[key];
                    let r_str = n_key;
                    if (n_key.indexOf("&#91;")) {
                        r_str = r_str.replace(/\[/g, '&#91;');
                    }
                    if (n_key.indexOf("&#93;")) {
                        r_str = r_str.replace(/\]/g, '&#93;');
                    }
                    if (n_key.indexOf("&#124;")) {
                        r_str = r_str.replace(/\|/g, '&#124;');
                    }
                    n_key = r_str;
                    let regex = new RegExp(n_key, "gi");
                    // console.log(regex, value);
                    email_body = email_body.replace(regex, value);
                });
            }
        }
        /** /--spinner variable replacement **/
        email_body = email_body.replace(/null/g, '');
        setTimeout(() => { callback(1, email_body); }, 200);
    }
    EmailRecruiting(tempdata, callback) {
        let email_body = tempdata.template;
        let leaddata = tempdata.cdata;
        email_body = email_body.replace(/{NAME}/g, leaddata.name);
        email_body = email_body.replace(/{ADDRESS}/g, leaddata.address);
        email_body = email_body.replace(/{CITY}/g, leaddata.city);
        email_body = email_body.replace(/{STATE}/g, leaddata.state);
        email_body = email_body.replace(/{ZIP}/g, leaddata.zip);
        email_body = email_body.replace(/{APPOINTMENT_DATE}/g, leaddata.date);
        email_body = email_body.replace(/{APPOINTMENTS_DATE}/g, leaddata.date);
        email_body = email_body.replace(/{APPOINTMENT_TIME}/g, leaddata.from_or_contact_time + "-" + leaddata.to_or_agent_time);
        email_body = email_body.replace(/{APPOINTMENT_START_TIME}/g, leaddata.from_or_contact_time);
        email_body = email_body.replace(/{APPOINTMENT_END_TIME}/g, leaddata.to_or_agent_time);
        email_body = email_body.replace(/{APPOINTMENT_COMMENTS}/g, leaddata.comments);
        if (leaddata.place) {
            email_body = email_body.replace(/{APPOINTMENT_PLACE}/g, leaddata.place);
            email_body = email_body.replace(/{ZOOM}/g, leaddata.place);
        }
        else {
            email_body = email_body.replace(/{APPOINTMENT_PLACE}/g, " ");
            email_body = email_body.replace(/{ZOOM}/g, " ");
        }
        email_body = email_body.replace(/{PHONE}/g, leaddata.phone);
        email_body = email_body.replace(/{CELL_PHONE}/g, leaddata.cell_phone);
        email_body = email_body.replace(/{EMAIL}/g, leaddata.email);
        email_body = email_body.replace(/{JOB}/g, leaddata.job);
        email_body = email_body.replace(/{ASSIGN_DATE}/g, leaddata.assign_date);
        email_body = email_body.replace(/{RATING}/g, leaddata.rating);
        email_body = email_body.replace(/{STAR_RATING}/g, leaddata.star_rating);
        email_body = email_body.replace(/{NOTES}/g, leaddata.notes);
        email_body = email_body.replace(/{LABELS}/g, leaddata.labels);
        email_body = email_body.replace(/{CANDIDATE_OVERVIEW}/g, leaddata.candidate_overview);
        email_body = email_body.replace(/{RESUME}/g, leaddata.resume);
        email_body = email_body.replace(/{DEALBREAKERQUESCORRECT}/g, leaddata.dealbreakerquescorrect);
        email_body = email_body.replace(/{QUES_ANS}/g, leaddata.ques_ans);
        email_body = email_body.replace(/{RECENT_COMP}/g, leaddata.recent_comp);
        email_body = email_body.replace(/{RECENT_POST}/g, leaddata.recent_post);
        email_body = email_body.replace(/{DURATION}/g, leaddata.duration);
        email_body = email_body.replace(/{RECENT_PAY}/g, leaddata.recent_pay);
        email_body = email_body.replace(/{SCHOOL}/g, leaddata.school);
        email_body = email_body.replace(/{MAJOR}/g, leaddata.major);
        email_body = email_body.replace(/{DEGREE}/g, leaddata.degree);
        email_body = email_body.replace(/{EXP}/g, leaddata.exp);
        email_body = email_body.replace(/{USCITIZON}/g, leaddata.uscitizon);
        email_body = email_body.replace(/{WORKTIMEZONE}/g, leaddata.worktimezone);
        email_body = email_body.replace(/{ISFELONY}/g, leaddata.isfelony);
        email_body = email_body.replace(/{PREVIOUSEMPLOYMENT}/g, leaddata.previousemployment);
        email_body = email_body.replace(/{MOSTLIKE}/g, leaddata.mostlike);
        email_body = email_body.replace(/{LEASTLIKE}/g, leaddata.leastlike);
        email_body = email_body.replace(/{INCOME}/g, leaddata.income);
        email_body = email_body.replace(/{COMMENTS}/g, leaddata.notes);
        email_body = email_body.replace(/{FIELD1}/g, leaddata.field1);
        email_body = email_body.replace(/{FIELD2}/g, leaddata.field2);
        email_body = email_body.replace(/{FIELD3}/g, leaddata.field3);
        email_body = email_body.replace(/{FIELD4}/g, leaddata.field4);
        email_body = email_body.replace(/{FIELD5}/g, leaddata.field5);
        email_body = email_body.replace(/{FIELD6}/g, leaddata.field6);
        email_body = email_body.replace(/{AGENT_FIRSTNAME}/g, tempdata.agfirst_name);
        email_body = email_body.replace(/{AGENT_LASTNAME}/g, tempdata.aglast_name);
        email_body = email_body.replace(/{AGENT_CONTACT}/g, tempdata.agcontact);
        email_body = email_body.replace(/{AGENT_EMAIL}/g, tempdata.agemail);
        email_body = email_body.replace(/{AGENT_FULLNAME}/g, tempdata.agfirst_name + " " + tempdata.aglast_name);
        /** spinner variable replacement **/
        if (email_body) {
            let qualityRegex = /\[[^\]]*\]/g, matches, qualities = [], spinner = [];
            while (matches = qualityRegex.exec(email_body)) {
                qualities.push(decodeURIComponent(matches));
            }
            if (qualities && Array.isArray(qualities)) {
                qualities.forEach(function (value, key) {
                    let n_value = value.replace(/[\[\]']+/g, '');
                    n_value = n_value.split('|');
                    spinner.push(n_value[Math.floor(Math.random() * n_value.length)]);
                });
            }
            let r_str = email_body;
            if (email_body.indexOf("&#91;")) {
                r_str = r_str.replace(/\[/g, '&#91;');
            }
            if (email_body.indexOf("&#93;")) {
                r_str = r_str.replace(/\]/g, '&#93;');
            }
            if (email_body.indexOf("&#124;")) {
                r_str = r_str.replace(/\|/g, '&#124;');
            }
            email_body = r_str;
            if (spinner && Array.isArray(spinner)) {
                spinner.forEach(function (value, key) {
                    let n_key = qualities[key];
                    let r_str = n_key;
                    if (n_key.indexOf("&#91;")) {
                        r_str = r_str.replace(/\[/g, '&#91;');
                    }
                    if (n_key.indexOf("&#93;")) {
                        r_str = r_str.replace(/\]/g, '&#93;');
                    }
                    if (n_key.indexOf("&#124;")) {
                        r_str = r_str.replace(/\|/g, '&#124;');
                    }
                    n_key = r_str;
                    let regex = new RegExp(n_key, "gi");
                    // console.log(regex, value);
                    email_body = email_body.replace(regex, value);
                });
            }
        }
        /** /--spinner variable replacement **/
        email_body = email_body.replace(/null/g, '');
        setTimeout(() => { callback(1, email_body); }, 200);
    }
}
exports.VariableParse = VariableParse;
